"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "defaultExtractor", {
    enumerable: !0,
    get: ()=>defaultExtractor
});
const _featureFlags = require("../featureFlags"), _regex = function(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) return obj;
    if (null === obj || "object" != typeof obj && "function" != typeof obj) return {
        default: obj
    };
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) return cache.get(obj);
    var newObj = {}, hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj)if ("default" !== key && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
    }
    return newObj.default = obj, cache && cache.set(obj, newObj), newObj;
}(require("./regex"));
function _getRequireWildcardCache(nodeInterop) {
    if ("function" != typeof WeakMap) return null;
    var cacheBabelInterop = new WeakMap(), cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function defaultExtractor(context) {
    let patterns = Array.from(function*(context) {
        let separator = context.tailwindConfig.separator, variantGroupingEnabled = (0, _featureFlags.flagEnabled)(context.tailwindConfig, "variantGrouping"), prefix = "" !== context.tailwindConfig.prefix ? _regex.optional(_regex.pattern([
            /-?/,
            _regex.escape(context.tailwindConfig.prefix)
        ])) : "", utility = _regex.any([
            /\[[^\s:'"`]+:[^\s\[\]]+\]/,
            /\[[^\s:'"`]+:[^\s]+?\[[^\s]+\][^\s]+?\]/,
            _regex.pattern([
                /-?(?:\w+)/,
                _regex.optional(_regex.any([
                    _regex.pattern([
                        /-(?:\w+-)*\[[^\s:]+\]/,
                        /(?![{([]])/,
                        /(?:\/[^\s'"`\\><$]*)?/
                    ]),
                    _regex.pattern([
                        /-(?:\w+-)*\[[^\s]+\]/,
                        /(?![{([]])/,
                        /(?:\/[^\s'"`\\$]*)?/
                    ]),
                    /[-\/][^\s'"`\\$={><]*/
                ]))
            ])
        ]);
        for (let variantPattern of [
            _regex.any([
                _regex.pattern([
                    /@\[[^\s"'`]+\](\/[^\s"'`]+)?/,
                    separator
                ]),
                _regex.pattern([
                    /([^\s"'`\[\\]+-)?\[[^\s"'`]+\]/,
                    separator
                ]),
                _regex.pattern([
                    /[^\s"'`\[\\]+/,
                    separator
                ])
            ]),
            _regex.any([
                _regex.pattern([
                    /([^\s"'`\[\\]+-)?\[[^\s`]+\]/,
                    separator
                ]),
                _regex.pattern([
                    /[^\s`\[\\]+/,
                    separator
                ])
            ])
        ])yield _regex.pattern([
            "((?=((",
            variantPattern,
            ")+))\\2)?",
            /!?/,
            prefix,
            variantGroupingEnabled ? _regex.any([
                _regex.pattern([
                    /\(/,
                    utility,
                    _regex.zeroOrMore([
                        /,/,
                        utility
                    ]),
                    /\)/
                ]),
                utility
            ]) : utility
        ]);
        yield /[^<>"'`\s.(){}[\]#=%$]*[^<>"'`\s.(){}[\]#=%:$]/g;
    }(context));
    return (content)=>{
        var _content_match;
        let results = [];
        for (let pattern of patterns)results = [
            ...results,
            ...null !== (_content_match = content.match(pattern)) && void 0 !== _content_match ? _content_match : []
        ];
        return results.filter((v)=>void 0 !== v).map(clipAtBalancedParens);
    };
}
let SPECIALS = /([\[\]'"`])([^\[\]'"`])?/g, ALLOWED_CLASS_CHARACTERS = /[^"'`\s<>\]]+/;
function clipAtBalancedParens(input) {
    if (!input.includes("-[")) return input;
    let depth = 0, openStringTypes = [], matches = input.matchAll(SPECIALS);
    for (let match of matches = Array.from(matches).flatMap((match)=>{
        let [, ...groups] = match;
        return groups.map((group, idx)=>Object.assign([], match, {
                index: match.index + idx,
                0: group
            }));
    })){
        let char = match[0], inStringType = openStringTypes[openStringTypes.length - 1];
        if (char === inStringType ? openStringTypes.pop() : ("'" === char || '"' === char || "`" === char) && openStringTypes.push(char), !inStringType) {
            if ("[" === char) {
                depth++;
                continue;
            }
            if ("]" === char) {
                depth--;
                continue;
            }
            if (depth < 0) return input.substring(0, match.index - 1);
            if (0 === depth && !ALLOWED_CLASS_CHARACTERS.test(char)) return input.substring(0, match.index);
        }
    }
    return input;
}
