"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: ()=>_default
});
const _dlv = _interopRequireDefault(require("dlv")), _didyoumean = _interopRequireDefault(require("didyoumean")), _transformThemeValue = _interopRequireDefault(require("../util/transformThemeValue")), _postcssValueParser = _interopRequireDefault(require("postcss-value-parser")), _normalizeScreens = require("../util/normalizeScreens"), _buildMediaQuery = _interopRequireDefault(require("../util/buildMediaQuery")), _toPath = require("../util/toPath"), _withAlphaVariable = require("../util/withAlphaVariable"), _pluginUtils = require("../util/pluginUtils"), _log = _interopRequireDefault(require("../util/log"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function isObject(input) {
    return "object" == typeof input && null !== input;
}
function pathToString(path) {
    return "string" == typeof path ? path : path.reduce((acc, cur, i)=>cur.includes(".") ? `${acc}[${cur}]` : 0 === i ? cur : `${acc}.${cur}`, "");
}
function list(items) {
    return items.map((key)=>`'${key}'`).join(", ");
}
function listKeys(obj) {
    return list(Object.keys(obj));
}
let nodeTypePropertyMap = {
    atrule: "params",
    decl: "value"
};
function _default(context) {
    let config = context.tailwindConfig, functions = {
        theme: (node, path, ...defaultValue)=>{
            let { isValid , value , error , alpha  } = function(config, path, defaultValue) {
                var _results_find;
                let results = Array.from(function*(path) {
                    let matches = (path = path.replace(/^['"]+|['"]+$/g, "")).match(/^([^\s]+)(?![^\[]*\])(?:\s*\/\s*([^\/\s]+))$/);
                    yield [
                        path,
                        void 0
                    ], matches && (yield [
                        path = matches[1],
                        matches[2]
                    ]);
                }(path)).map(([path, alpha])=>Object.assign(function validatePath(config, path, defaultValue, themeOpts = {}) {
                        let pathString = Array.isArray(path) ? pathToString(path) : path.replace(/^['"]+|['"]+$/g, ""), pathSegments = Array.isArray(path) ? path : (0, _toPath.toPath)(pathString), value = (0, _dlv.default)(config.theme, pathSegments, defaultValue);
                        if (void 0 === value) {
                            let error = `'${pathString}' does not exist in your theme config.`, parentSegments = pathSegments.slice(0, -1), parentValue = (0, _dlv.default)(config.theme, parentSegments);
                            if (isObject(parentValue)) {
                                let validKeys = Object.keys(parentValue).filter((key)=>validatePath(config, [
                                        ...parentSegments,
                                        key
                                    ]).isValid), suggestion = (0, _didyoumean.default)(pathSegments[pathSegments.length - 1], validKeys);
                                suggestion ? error += ` Did you mean '${pathToString([
                                    ...parentSegments,
                                    suggestion
                                ])}'?` : validKeys.length > 0 && (error += ` '${pathToString(parentSegments)}' has the following valid keys: ${list(validKeys)}`);
                            } else {
                                let closestPath = function(theme, path) {
                                    let parts = (0, _toPath.toPath)(path);
                                    do if (parts.pop(), void 0 !== (0, _dlv.default)(theme, parts)) break;
                                    while (parts.length);
                                    return parts.length ? parts : void 0;
                                }(config.theme, pathString);
                                if (closestPath) {
                                    let closestValue = (0, _dlv.default)(config.theme, closestPath);
                                    isObject(closestValue) ? error += ` '${pathToString(closestPath)}' has the following keys: ${listKeys(closestValue)}` : error += ` '${pathToString(closestPath)}' is not an object.`;
                                } else error += ` Your theme has the following top-level keys: ${listKeys(config.theme)}`;
                            }
                            return {
                                isValid: !1,
                                error
                            };
                        }
                        if (!("string" == typeof value || "number" == typeof value || "function" == typeof value || value instanceof String || value instanceof Number || Array.isArray(value))) {
                            let error1 = `'${pathString}' was found but does not resolve to a string.`;
                            if (isObject(value)) {
                                let validKeys1 = Object.keys(value).filter((key)=>validatePath(config, [
                                        ...pathSegments,
                                        key
                                    ]).isValid);
                                validKeys1.length && (error1 += ` Did you mean something like '${pathToString([
                                    ...pathSegments,
                                    validKeys1[0]
                                ])}'?`);
                            }
                            return {
                                isValid: !1,
                                error: error1
                            };
                        }
                        let [themeSection] = pathSegments;
                        return {
                            isValid: !0,
                            value: (0, _transformThemeValue.default)(themeSection)(value, themeOpts)
                        };
                    }(config, path, defaultValue, {
                        opacityValue: alpha
                    }), {
                        resolvedPath: path,
                        alpha
                    }));
                return null !== (_results_find = results.find((result)=>result.isValid)) && void 0 !== _results_find ? _results_find : results[0];
            }(config, path, defaultValue.length ? defaultValue : void 0);
            if (!isValid) {
                var _parentNode_raws_tailwind;
                let parentNode = node.parent, candidate = null === (_parentNode_raws_tailwind = null == parentNode ? void 0 : parentNode.raws.tailwind) || void 0 === _parentNode_raws_tailwind ? void 0 : _parentNode_raws_tailwind.candidate;
                if (parentNode && void 0 !== candidate) {
                    context.markInvalidUtilityNode(parentNode), parentNode.remove(), _log.default.warn("invalid-theme-key-in-class", [
                        `The utility \`${candidate}\` contains an invalid theme value and was not generated.`
                    ]);
                    return;
                }
                throw node.error(error);
            }
            let maybeColor = (0, _pluginUtils.parseColorFormat)(value);
            return (void 0 !== alpha || void 0 !== maybeColor && "function" == typeof maybeColor) && (void 0 === alpha && (alpha = 1.0), value = (0, _withAlphaVariable.withAlphaValue)(maybeColor, alpha, maybeColor)), value;
        },
        screen: (node, screen)=>{
            screen = screen.replace(/^['"]+/g, "").replace(/['"]+$/g, "");
            let screenDefinition = (0, _normalizeScreens.normalizeScreens)(config.theme.screens).find(({ name  })=>name === screen);
            if (!screenDefinition) throw node.error(`The '${screen}' screen does not exist in your theme.`);
            return (0, _buildMediaQuery.default)(screenDefinition);
        }
    };
    return (root)=>{
        root.walk((node)=>{
            let property = nodeTypePropertyMap[node.type];
            if (void 0 !== property) {
                var input;
                node[property] = (input = node[property], (0, _postcssValueParser.default)(input).walk((vNode)=>{
                    (function resolveVNode(node, vNode, functions) {
                        if ("function" === vNode.type && void 0 !== functions[vNode.value]) {
                            let args = function(node, vNodes, functions) {
                                vNodes = vNodes.map((vNode)=>resolveVNode(node, vNode, functions));
                                let args = [
                                    ""
                                ];
                                for (let vNode of vNodes)"div" === vNode.type && "," === vNode.value ? args.push("") : args[args.length - 1] += _postcssValueParser.default.stringify(vNode);
                                return args;
                            }(node, vNode.nodes, functions);
                            vNode.type = "word", vNode.value = functions[vNode.value](node, ...args);
                        }
                        return vNode;
                    })(node, vNode, functions);
                }).toString());
            }
        });
    };
}
