"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: ()=>expandApplyAtRules
});
const _postcss = _interopRequireDefault(require("postcss")), _postcssSelectorParser = _interopRequireDefault(require("postcss-selector-parser")), _generateRules = require("./generateRules"), _escapeClassName = _interopRequireDefault(require("../util/escapeClassName")), _applyImportantSelector = require("../util/applyImportantSelector"), _pseudoElements = require("../util/pseudoElements");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function extractClasses(node) {
    let groups = new Map();
    _postcss.default.root({
        nodes: [
            node.clone()
        ]
    }).walkRules((rule)=>{
        (0, _postcssSelectorParser.default)((selectors)=>{
            selectors.walkClasses((classSelector)=>{
                let parentSelector = classSelector.parent.toString(), classes = groups.get(parentSelector);
                classes || groups.set(parentSelector, classes = new Set()), classes.add(classSelector.value);
            });
        }).processSync(rule.selector);
    });
    let normalizedGroups = Array.from(groups.values(), (classes)=>Array.from(classes));
    return Object.assign(normalizedGroups.flat(), {
        groups: normalizedGroups
    });
}
let selectorExtractor = (0, _postcssSelectorParser.default)();
function extractSelectors(ruleSelectors) {
    return selectorExtractor.astSync(ruleSelectors);
}
function extractBaseCandidates(candidates, separator) {
    let baseClasses = new Set();
    for (let candidate of candidates)baseClasses.add(candidate.split(separator).pop());
    return Array.from(baseClasses);
}
function prefix(context, selector) {
    let prefix = context.tailwindConfig.prefix;
    return "function" == typeof prefix ? prefix(selector) : prefix + selector;
}
function* pathToRoot(node) {
    for(yield node; node.parent;)yield node.parent, node = node.parent;
}
function extractApplyCandidates(params) {
    let candidates = params.split(/[\s\t\n]+/g);
    return "!important" === candidates[candidates.length - 1] ? [
        candidates.slice(0, -1),
        !0
    ] : [
        candidates,
        !1
    ];
}
function expandApplyAtRules(context) {
    return (root)=>{
        var buildCacheFn;
        let cache;
        let localCache = (buildCacheFn = ()=>{
            let cache;
            return cache = new Map(), root.walkRules((rule)=>{
                for (let node of pathToRoot(rule)){
                    var _node_raws_tailwind;
                    if ((null === (_node_raws_tailwind = node.raws.tailwind) || void 0 === _node_raws_tailwind ? void 0 : _node_raws_tailwind.layer) !== void 0) return;
                }
                let container = function(node) {
                    for (let parent of pathToRoot(node))if (node !== parent) {
                        if ("root" === parent.type) break;
                        node = function(node, overrides = {}) {
                            let children = node.nodes;
                            node.nodes = [];
                            let tmp = node.clone(overrides);
                            return node.nodes = children, tmp;
                        }(parent, {
                            nodes: [
                                node
                            ]
                        });
                    }
                    return node;
                }(rule), sort = context.offsets.create("user");
                for (let className of extractClasses(rule)){
                    let list = cache.get(className) || [];
                    cache.set(className, list), list.push([
                        {
                            layer: "user",
                            sort,
                            important: !1
                        },
                        container
                    ]);
                }
            }), cache;
        }, cache = null, {
            get: (name)=>(cache = cache || buildCacheFn()).get(name),
            has: (name)=>(cache = cache || buildCacheFn()).has(name)
        });
        !function processApply(root, context, localCache) {
            var caches;
            let applyCandidates = new Set(), applies = [];
            if (root.walkAtRules("apply", (rule)=>{
                let [candidates] = extractApplyCandidates(rule.params);
                for (let util of candidates)applyCandidates.add(util);
                applies.push(rule);
            }), 0 === applies.length) return;
            let applyClassCache = (caches = [
                localCache,
                function(applyCandidates, context) {
                    for (let candidate of applyCandidates){
                        if (context.notClassCache.has(candidate) || context.applyClassCache.has(candidate)) continue;
                        if (context.classCache.has(candidate)) {
                            context.applyClassCache.set(candidate, context.classCache.get(candidate).map(([meta, rule])=>[
                                    meta,
                                    rule.clone()
                                ]));
                            continue;
                        }
                        let matches = Array.from((0, _generateRules.resolveMatches)(candidate, context));
                        if (0 === matches.length) {
                            context.notClassCache.add(candidate);
                            continue;
                        }
                        context.applyClassCache.set(candidate, matches);
                    }
                    return context.applyClassCache;
                }(applyCandidates, context)
            ], {
                get: (name)=>caches.flatMap((cache)=>cache.get(name) || []),
                has: (name)=>caches.some((cache)=>cache.has(name))
            }), perParentApplies = new Map();
            for (let apply of applies){
                let [candidates] = perParentApplies.get(apply.parent) || [
                    [],
                    apply.source
                ];
                perParentApplies.set(apply.parent, [
                    candidates,
                    apply.source
                ]);
                let [applyCandidates1, important] = extractApplyCandidates(apply.params);
                if ("atrule" === apply.parent.type) {
                    if ("screen" === apply.parent.name) {
                        let screenType = apply.parent.params;
                        throw apply.error(`@apply is not supported within nested at-rules like @screen. We suggest you write this as @apply ${applyCandidates1.map((c)=>`${screenType}:${c}`).join(" ")} instead.`);
                    }
                    throw apply.error(`@apply is not supported within nested at-rules like @${apply.parent.name}. You can fix this by un-nesting @${apply.parent.name}.`);
                }
                for (let applyCandidate of applyCandidates1){
                    if ([
                        prefix(context, "group"),
                        prefix(context, "peer")
                    ].includes(applyCandidate)) throw apply.error(`@apply should not be used with the '${applyCandidate}' utility`);
                    if (!applyClassCache.has(applyCandidate)) throw apply.error(`The \`${applyCandidate}\` class does not exist. If \`${applyCandidate}\` is a custom class, make sure it is defined within a \`@layer\` directive.`);
                    let rules = applyClassCache.get(applyCandidate);
                    candidates.push([
                        applyCandidate,
                        important,
                        rules
                    ]);
                }
            }
            for (let [parent, [candidates1, atApplySource]] of perParentApplies){
                let siblings = [];
                for (let [applyCandidate1, important1, rules1] of candidates1){
                    let potentialApplyCandidates = [
                        applyCandidate1,
                        ...extractBaseCandidates([
                            applyCandidate1
                        ], context.tailwindConfig.separator)
                    ];
                    for (let [meta, node] of rules1){
                        let parentClasses = extractClasses(parent), nodeClasses = extractClasses(node);
                        if (nodeClasses = (nodeClasses = nodeClasses.groups.filter((classList)=>classList.some((className)=>potentialApplyCandidates.includes(className))).flat()).concat(extractBaseCandidates(nodeClasses, context.tailwindConfig.separator)), parentClasses.some((selector)=>nodeClasses.includes(selector))) throw node.error(`You cannot \`@apply\` the \`${applyCandidate1}\` utility here because it creates a circular dependency.`);
                        let root1 = _postcss.default.root({
                            nodes: [
                                node.clone()
                            ]
                        });
                        root1.walk((node)=>{
                            node.source = atApplySource;
                        }), ("atrule" !== node.type || "atrule" === node.type && "keyframes" !== node.name) && root1.walkRules((rule)=>{
                            if (!extractClasses(rule).some((candidate)=>candidate === applyCandidate1)) {
                                rule.remove();
                                return;
                            }
                            let importantSelector = "string" == typeof context.tailwindConfig.important ? context.tailwindConfig.important : null, parentSelector = void 0 !== parent.raws.tailwind && importantSelector && 0 === parent.selector.indexOf(importantSelector) ? parent.selector.slice(importantSelector.length) : parent.selector;
                            rule.selector = function(selector, utilitySelectors, candidate) {
                                let selectorList = extractSelectors(selector), utilitySelectorsList = extractSelectors(utilitySelectors), candidateClass = extractSelectors(`.${(0, _escapeClassName.default)(candidate)}`).nodes[0].nodes[0];
                                return selectorList.each((sel)=>{
                                    let replaced = new Set();
                                    for (let sel1 of (utilitySelectorsList.each((utilitySelector)=>{
                                        let hasReplaced = !1;
                                        (utilitySelector = utilitySelector.clone()).walkClasses((node)=>{
                                            node.value === candidateClass.value && (hasReplaced || (node.replaceWith(...sel.nodes.map((node)=>node.clone())), replaced.add(utilitySelector), hasReplaced = !0));
                                        });
                                    }), replaced)){
                                        let groups = [
                                            []
                                        ];
                                        for (let node of sel1.nodes)"combinator" === node.type ? (groups.push(node), groups.push([])) : groups[groups.length - 1].push(node);
                                        for (let group of (sel1.nodes = [], groups))Array.isArray(group) && group.sort((a, b)=>"tag" === a.type && "class" === b.type ? -1 : "class" === a.type && "tag" === b.type ? 1 : "class" === a.type && "pseudo" === b.type && b.value.startsWith("::") ? -1 : "pseudo" === a.type && a.value.startsWith("::") && "class" === b.type ? 1 : 0), sel1.nodes = sel1.nodes.concat(group);
                                    }
                                    sel.replaceWith(...replaced);
                                }), selectorList.toString();
                            }(parentSelector, rule.selector, applyCandidate1), importantSelector && parentSelector !== parent.selector && (rule.selector = (0, _applyImportantSelector.applyImportantSelector)(rule.selector, importantSelector)), rule.walkDecls((d)=>{
                                d.important = meta.important || important1;
                            });
                            let selector = (0, _postcssSelectorParser.default)().astSync(rule.selector);
                            selector.each((sel)=>(0, _pseudoElements.movePseudos)(sel)), rule.selector = selector.toString();
                        }), root1.nodes[0] && siblings.push([
                            meta.sort,
                            root1.nodes[0]
                        ]);
                    }
                }
                let nodes = context.offsets.sort(siblings).map((s)=>s[1]);
                parent.after(nodes);
            }
            for (let apply1 of applies)apply1.parent.nodes.length > 1 ? apply1.remove() : apply1.parent.remove();
            processApply(root, context, localCache);
        }(root, context, localCache);
    };
}
