"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "findAtConfigPath", {
    enumerable: !0,
    get: ()=>findAtConfigPath
});
const _fs = _interopRequireDefault(require("fs")), _path = _interopRequireDefault(require("path"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function findAtConfigPath(root, result) {
    let configPath = null, relativeTo = null;
    return root.walkAtRules("config", (rule)=>{
        var _rule_source, _rule_source_input_file, _ref;
        if (null === (relativeTo = null !== (_ref = null !== (_rule_source_input_file = null === (_rule_source = rule.source) || void 0 === _rule_source ? void 0 : _rule_source.input.file) && void 0 !== _rule_source_input_file ? _rule_source_input_file : result.opts.from) && void 0 !== _ref ? _ref : null)) throw rule.error("The `@config` directive cannot be used without setting `from` in your PostCSS config.");
        if (configPath) throw rule.error("Only one `@config` directive is allowed per file.");
        let matches = rule.params.match(/(['"])(.*?)\1/);
        if (!matches) throw rule.error("A path is required when using the `@config` directive.");
        let inputPath = matches[2];
        if (_path.default.isAbsolute(inputPath)) throw rule.error("The `@config` directive cannot be used with an absolute path.");
        if (configPath = _path.default.resolve(_path.default.dirname(relativeTo), inputPath), !_fs.default.existsSync(configPath)) throw rule.error(`The config file at "${inputPath}" does not exist. Make sure the path is correct and the file exists.`);
        rule.remove();
    }), configPath || null;
}
