"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), function(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: !0,
        get: all[name]
    });
}(exports, {
    getClassNameFromSelector: ()=>getClassNameFromSelector,
    resolveMatches: ()=>resolveMatches,
    generateRules: ()=>generateRules
});
const _postcss = _interopRequireDefault(require("postcss")), _postcssSelectorParser = _interopRequireDefault(require("postcss-selector-parser")), _parseObjectStyles = _interopRequireDefault(require("../util/parseObjectStyles")), _isPlainObject = _interopRequireDefault(require("../util/isPlainObject")), _prefixSelector = _interopRequireDefault(require("../util/prefixSelector")), _pluginUtils = require("../util/pluginUtils"), _log = _interopRequireDefault(require("../util/log")), _sharedState = function(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) return obj;
    if (null === obj || "object" != typeof obj && "function" != typeof obj) return {
        default: obj
    };
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) return cache.get(obj);
    var newObj = {}, hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj)if ("default" !== key && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
    }
    return newObj.default = obj, cache && cache.set(obj, newObj), newObj;
}(require("./sharedState")), _formatVariantSelector = require("../util/formatVariantSelector"), _nameClass = require("../util/nameClass"), _dataTypes = require("../util/dataTypes"), _setupContextUtils = require("./setupContextUtils"), _isSyntacticallyValidPropertyValue = _interopRequireDefault(require("../util/isSyntacticallyValidPropertyValue")), _splitAtTopLevelOnlyJs = require("../util/splitAtTopLevelOnly.js"), _featureFlags = require("../featureFlags"), _applyImportantSelector = require("../util/applyImportantSelector");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _getRequireWildcardCache(nodeInterop) {
    if ("function" != typeof WeakMap) return null;
    var cacheBabelInterop = new WeakMap(), cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
let classNameParser = (0, _postcssSelectorParser.default)((selectors)=>selectors.first.filter(({ type  })=>"class" === type).pop().value);
function getClassNameFromSelector(selector) {
    return classNameParser.transformSync(selector);
}
function parseRules(rule, cache, options = {}) {
    return (0, _isPlainObject.default)(rule) || Array.isArray(rule) ? Array.isArray(rule) ? parseRules(rule[0], cache, rule[1]) : (cache.has(rule) || cache.set(rule, (0, _parseObjectStyles.default)(rule)), [
        cache.get(rule),
        options
    ]) : [
        [
            rule
        ],
        options
    ];
}
const IS_VALID_PROPERTY_NAME = /^[a-z_-]/;
function isParsableNode(node) {
    let isParsable = !0;
    return node.walkDecls((decl)=>{
        if (!isParsableCssValue(decl.prop, decl.value)) return isParsable = !1, !1;
    }), isParsable;
}
function isParsableCssValue(property, value) {
    if (function(declaration) {
        if (!declaration.includes("://")) return !1;
        try {
            let url = new URL(declaration);
            return "" !== url.scheme && "" !== url.host;
        } catch (err) {
            return !1;
        }
    }(`${property}:${value}`)) return !1;
    try {
        return _postcss.default.parse(`a{${property}:${value}}`).toResult(), !0;
    } catch (err) {
        return !1;
    }
}
function* resolveMatches(candidate, context, original = candidate) {
    var _sort_options, _sort_options_types, _sort_options1, _findFallback, _typesByMatches_get;
    let separator = context.tailwindConfig.separator, [classCandidate, ...variants] = (candidate === _sharedState.NOT_ON_DEMAND ? [
        _sharedState.NOT_ON_DEMAND
    ] : (0, _splitAtTopLevelOnlyJs.splitAtTopLevelOnly)(candidate, separator)).reverse(), important = !1;
    if (classCandidate.startsWith("!") && (important = !0, classCandidate = classCandidate.slice(1)), (0, _featureFlags.flagEnabled)(context.tailwindConfig, "variantGrouping") && classCandidate.startsWith("(") && classCandidate.endsWith(")")) {
        let base = variants.slice().reverse().join(separator);
        for (let part of (0, _splitAtTopLevelOnlyJs.splitAtTopLevelOnly)(classCandidate.slice(1, -1), ","))yield* resolveMatches(base + separator + part, context, original);
    }
    for (let matchedPlugins of function*(classCandidate, context) {
        context.candidateRuleMap.has(classCandidate) && (yield [
            context.candidateRuleMap.get(classCandidate),
            "DEFAULT"
        ]), yield* function*(arbitraryPropertyRule) {
            null !== arbitraryPropertyRule && (yield [
                arbitraryPropertyRule,
                "DEFAULT"
            ]);
        }(function(classCandidate, context) {
            var _classCandidate_match;
            let [, property, value] = null !== (_classCandidate_match = classCandidate.match(/^\[([a-zA-Z0-9-_]+):(\S+)\]$/)) && void 0 !== _classCandidate_match ? _classCandidate_match : [];
            if (void 0 === value || !IS_VALID_PROPERTY_NAME.test(property) || !(0, _isSyntacticallyValidPropertyValue.default)(value)) return null;
            let normalized = (0, _dataTypes.normalize)(value);
            if (!isParsableCssValue(property, normalized)) return null;
            let sort = context.offsets.arbitraryProperty();
            return [
                [
                    {
                        sort,
                        layer: "utilities"
                    },
                    ()=>({
                            [(0, _nameClass.asClass)(classCandidate)]: {
                                [property]: normalized
                            }
                        })
                ]
            ];
        }(classCandidate, context));
        let candidatePrefix = classCandidate, negative = !1, twConfigPrefix = context.tailwindConfig.prefix, twConfigPrefixLen = twConfigPrefix.length, hasMatchingPrefix = candidatePrefix.startsWith(twConfigPrefix) || candidatePrefix.startsWith(`-${twConfigPrefix}`);
        for (let [prefix, modifier] of ("-" === candidatePrefix[twConfigPrefixLen] && hasMatchingPrefix && (negative = !0, candidatePrefix = twConfigPrefix + candidatePrefix.slice(twConfigPrefixLen + 1)), negative && context.candidateRuleMap.has(candidatePrefix) && (yield [
            context.candidateRuleMap.get(candidatePrefix),
            "-DEFAULT"
        ]), function*(candidate) {
            let lastIndex = 1 / 0;
            for(; lastIndex >= 0;){
                let dashIdx;
                let wasSlash = !1;
                if (lastIndex === 1 / 0 && candidate.endsWith("]")) {
                    let bracketIdx = candidate.indexOf("[");
                    "-" === candidate[bracketIdx - 1] ? dashIdx = bracketIdx - 1 : "/" === candidate[bracketIdx - 1] ? (dashIdx = bracketIdx - 1, wasSlash = !0) : dashIdx = -1;
                } else lastIndex === 1 / 0 && candidate.includes("/") ? (dashIdx = candidate.lastIndexOf("/"), wasSlash = !0) : dashIdx = candidate.lastIndexOf("-", lastIndex);
                if (dashIdx < 0) break;
                let prefix = candidate.slice(0, dashIdx), modifier = candidate.slice(wasSlash ? dashIdx : dashIdx + 1);
                lastIndex = dashIdx - 1, "" !== prefix && "/" !== modifier && (yield [
                    prefix,
                    modifier
                ]);
            }
        }(candidatePrefix)))context.candidateRuleMap.has(prefix) && (yield [
            context.candidateRuleMap.get(prefix),
            negative ? `-${modifier}` : modifier
        ]);
    }(classCandidate, context)){
        let matches = [], typesByMatches = new Map(), [plugins, modifier] = matchedPlugins, isOnlyPlugin = 1 === plugins.length;
        for (let [sort, plugin] of plugins){
            let matchesPerPlugin = [];
            if ("function" == typeof plugin) for (let ruleSet of [].concat(plugin(modifier, {
                isOnlyPlugin
            }))){
                let [rules, options] = parseRules(ruleSet, context.postCssNodeCache);
                for (let rule of rules)matchesPerPlugin.push([
                    {
                        ...sort,
                        options: {
                            ...sort.options,
                            ...options
                        }
                    },
                    rule
                ]);
            }
            else if ("DEFAULT" === modifier || "-DEFAULT" === modifier) {
                let [rules1, options1] = parseRules(plugin, context.postCssNodeCache);
                for (let rule1 of rules1)matchesPerPlugin.push([
                    {
                        ...sort,
                        options: {
                            ...sort.options,
                            ...options1
                        }
                    },
                    rule1
                ]);
            }
            if (matchesPerPlugin.length > 0) {
                let matchingTypes = Array.from((0, _pluginUtils.getMatchingTypes)(null !== (_sort_options_types = null === (_sort_options = sort.options) || void 0 === _sort_options ? void 0 : _sort_options.types) && void 0 !== _sort_options_types ? _sort_options_types : [], modifier, null !== (_sort_options1 = sort.options) && void 0 !== _sort_options1 ? _sort_options1 : {}, context.tailwindConfig)).map(([_, type])=>type);
                matchingTypes.length > 0 && typesByMatches.set(matchesPerPlugin, matchingTypes), matches.push(matchesPerPlugin);
            }
        }
        if (isArbitraryValue(modifier)) {
            if (matches.length > 1) {
                let [withAny, withoutAny] = matches.reduce((group, plugin)=>(plugin.some(([{ options  }])=>options.types.some(({ type  })=>"any" === type)) ? group[0].push(plugin) : group[1].push(plugin), group), [
                    [],
                    []
                ]);
                function findFallback(matches) {
                    return 1 === matches.length ? matches[0] : matches.find((rules)=>{
                        let matchingTypes = typesByMatches.get(rules);
                        return rules.some(([{ options  }, rule])=>!!isParsableNode(rule) && options.types.some(({ type , preferOnConflict  })=>matchingTypes.includes(type) && preferOnConflict));
                    });
                }
                let fallback = null !== (_findFallback = findFallback(withoutAny)) && void 0 !== _findFallback ? _findFallback : findFallback(withAny);
                if (fallback) matches = [
                    fallback
                ];
                else {
                    let typesPerPlugin = matches.map((match)=>new Set([
                            ...null !== (_typesByMatches_get = typesByMatches.get(match)) && void 0 !== _typesByMatches_get ? _typesByMatches_get : []
                        ]));
                    for (let pluginTypes of typesPerPlugin)for (let type of pluginTypes){
                        let removeFromOwnGroup = !1;
                        for (let otherGroup of typesPerPlugin)pluginTypes !== otherGroup && otherGroup.has(type) && (otherGroup.delete(type), removeFromOwnGroup = !0);
                        removeFromOwnGroup && pluginTypes.delete(type);
                    }
                    let messages = [];
                    for (let [idx, group] of typesPerPlugin.entries())for (let type1 of group){
                        let rules2 = matches[idx].map(([, rule])=>rule).flat().map((rule)=>rule.toString().split("\n").slice(1, -1).map((line)=>line.trim()).map((x)=>`      ${x}`).join("\n")).join("\n\n");
                        messages.push(`  Use \`${candidate.replace("[", `[${type1}:`)}\` for \`${rules2.trim()}\``);
                        break;
                    }
                    _log.default.warn([
                        `The class \`${candidate}\` is ambiguous and matches multiple utilities.`,
                        ...messages,
                        `If this is content and not a class, replace it with \`${candidate.replace("[", "&lsqb;").replace("]", "&rsqb;")}\` to silence this warning.`
                    ]);
                    continue;
                }
            }
            matches = matches.map((list)=>list.filter((match)=>isParsableNode(match[1])));
        }
        for (let variant of (matches = function(matches, context) {
            if (0 === matches.length || "" === context.tailwindConfig.prefix) return matches;
            for (let match of matches){
                let [meta] = match;
                if (meta.options.respectPrefix) {
                    let container = _postcss.default.root({
                        nodes: [
                            match[1].clone()
                        ]
                    }), classCandidate = match[1].raws.tailwind.classCandidate;
                    container.walkRules((r)=>{
                        let shouldPrependNegative = classCandidate.startsWith("-");
                        r.selector = (0, _prefixSelector.default)(context.tailwindConfig.prefix, r.selector, shouldPrependNegative);
                    }), match[1] = container.nodes[0];
                }
            }
            return matches;
        }(matches = Array.from(function*(matches, classCandidate) {
            for (let match of matches){
                var _match__options, _match__options_preserveSource;
                match[1].raws.tailwind = {
                    ...match[1].raws.tailwind,
                    classCandidate,
                    preserveSource: null !== (_match__options_preserveSource = null === (_match__options = match[0].options) || void 0 === _match__options ? void 0 : _match__options.preserveSource) && void 0 !== _match__options_preserveSource && _match__options_preserveSource
                }, yield match;
            }
        }(matches = matches.flat(), classCandidate)), context), important && (matches = function(matches, classCandidate) {
            if (0 === matches.length) return matches;
            let result = [];
            for (let [meta, rule] of matches){
                let container = _postcss.default.root({
                    nodes: [
                        rule.clone()
                    ]
                });
                container.walkRules((r)=>{
                    let ast = (0, _postcssSelectorParser.default)().astSync(r.selector);
                    ast.each((sel)=>(0, _formatVariantSelector.eliminateIrrelevantSelectors)(sel, classCandidate)), (0, _pluginUtils.updateAllClasses)(ast, (className)=>className === classCandidate ? `!${className}` : className), r.selector = ast.toString(), r.walkDecls((d)=>d.important = !0);
                }), result.push([
                    {
                        ...meta,
                        important: !0
                    },
                    container.nodes[0]
                ]);
            }
            return result;
        }(matches, classCandidate)), variants))matches = function(variant, matches, context) {
            if (0 === matches.length) return matches;
            let args = {
                modifier: null,
                value: _sharedState.NONE
            };
            {
                let [baseVariant, ...modifiers] = (0, _splitAtTopLevelOnlyJs.splitAtTopLevelOnly)(variant, "/");
                if (modifiers.length > 1 && (baseVariant = baseVariant + "/" + modifiers.slice(0, -1).join("/"), modifiers = modifiers.slice(-1)), modifiers.length && !context.variantMap.has(variant) && (variant = baseVariant, args.modifier = modifiers[0], !(0, _featureFlags.flagEnabled)(context.tailwindConfig, "generalizedModifiers"))) return [];
            }
            if (variant.endsWith("]") && !variant.startsWith("[")) {
                let match = /(.)(-?)\[(.*)\]/g.exec(variant);
                if (match) {
                    let [, char, seperator, value] = match;
                    if ("@" === char && "-" === seperator || "@" !== char && "" === seperator) return [];
                    variant = variant.replace(`${seperator}[${value}]`, ""), args.value = value;
                }
            }
            if (isArbitraryValue(variant) && !context.variantMap.has(variant)) {
                let sort = context.offsets.recordVariant(variant), selector = (0, _dataTypes.normalize)(variant.slice(1, -1)), selectors = (0, _splitAtTopLevelOnlyJs.splitAtTopLevelOnly)(selector, ",");
                if (selectors.length > 1 || !selectors.every(_setupContextUtils.isValidVariantFormatString)) return [];
                let records = selectors.map((sel, idx)=>[
                        context.offsets.applyParallelOffset(sort, idx),
                        (0, _setupContextUtils.parseVariant)(sel.trim())
                    ]);
                context.variantMap.set(variant, records);
            }
            if (context.variantMap.has(variant)) {
                let isArbitraryVariant = isArbitraryValue(variant), variantFunctionTuples = context.variantMap.get(variant).slice(), result = [];
                for (let [meta, rule] of matches){
                    if ("user" === meta.layer) continue;
                    let container = _postcss.default.root({
                        nodes: [
                            rule.clone()
                        ]
                    });
                    for (let [variantSort, variantFunction, containerFromArray] of variantFunctionTuples){
                        var _meta_collectedFormats;
                        let clone = (null != containerFromArray ? containerFromArray : container).clone(), collectedFormats = [];
                        function prepareBackup() {
                            clone.raws.neededBackup || (clone.raws.neededBackup = !0, clone.walkRules((rule)=>rule.raws.originalSelector = rule.selector));
                        }
                        function modifySelectors(modifierFunction) {
                            return prepareBackup(), clone.each((rule)=>{
                                "rule" === rule.type && (rule.selectors = rule.selectors.map((selector)=>modifierFunction({
                                        get className () {
                                            return getClassNameFromSelector(selector);
                                        },
                                        selector
                                    })));
                            }), clone;
                        }
                        let ruleWithVariant = variantFunction({
                            get container () {
                                return prepareBackup(), clone;
                            },
                            separator: context.tailwindConfig.separator,
                            modifySelectors,
                            wrap (wrapper) {
                                let nodes = clone.nodes;
                                clone.removeAll(), wrapper.append(nodes), clone.append(wrapper);
                            },
                            format (selectorFormat) {
                                collectedFormats.push({
                                    format: selectorFormat,
                                    isArbitraryVariant
                                });
                            },
                            args
                        });
                        if (Array.isArray(ruleWithVariant)) {
                            for (let [idx, variantFunction1] of ruleWithVariant.entries())variantFunctionTuples.push([
                                context.offsets.applyParallelOffset(variantSort, idx),
                                variantFunction1,
                                clone.clone()
                            ]);
                            continue;
                        }
                        if ("string" == typeof ruleWithVariant && collectedFormats.push({
                            format: ruleWithVariant,
                            isArbitraryVariant
                        }), null === ruleWithVariant) continue;
                        clone.raws.neededBackup && (delete clone.raws.neededBackup, clone.walkRules((rule)=>{
                            let before = rule.raws.originalSelector;
                            if (!before || (delete rule.raws.originalSelector, before === rule.selector)) return;
                            let modified = rule.selector, rebuiltBase = (0, _postcssSelectorParser.default)((selectors)=>{
                                selectors.walkClasses((classNode)=>{
                                    classNode.value = `${variant}${context.tailwindConfig.separator}${classNode.value}`;
                                });
                            }).processSync(before);
                            collectedFormats.push({
                                format: modified.replace(rebuiltBase, "&"),
                                isArbitraryVariant
                            }), rule.selector = before;
                        })), clone.nodes[0].raws.tailwind = {
                            ...clone.nodes[0].raws.tailwind,
                            parentLayer: meta.layer
                        };
                        let withOffset = [
                            {
                                ...meta,
                                sort: context.offsets.applyVariantOffset(meta.sort, variantSort, Object.assign(args, context.variantOptions.get(variant))),
                                collectedFormats: (null !== (_meta_collectedFormats = meta.collectedFormats) && void 0 !== _meta_collectedFormats ? _meta_collectedFormats : []).concat(collectedFormats)
                            },
                            clone.nodes[0]
                        ];
                        result.push(withOffset);
                    }
                }
                return result;
            }
            return [];
        }(variant, matches, context);
        for (let match of matches)match[1].raws.tailwind = {
            ...match[1].raws.tailwind,
            candidate
        }, null !== (match = function(match, { context , candidate , original  }) {
            let finalFormat;
            if (!match[0].collectedFormats) return match;
            let isValid = !0;
            try {
                finalFormat = (0, _formatVariantSelector.formatVariantSelector)(match[0].collectedFormats, {
                    context,
                    candidate
                });
            } catch  {
                return null;
            }
            let container = _postcss.default.root({
                nodes: [
                    match[1].clone()
                ]
            });
            return (container.walkRules((rule)=>{
                if (!inKeyframes(rule)) try {
                    rule.selector = (0, _formatVariantSelector.finalizeSelector)(rule.selector, finalFormat, {
                        candidate: original,
                        context
                    });
                } catch  {
                    return isValid = !1, !1;
                }
            }), isValid) ? (match[1] = container.nodes[0], match) : null;
        }(match, {
            context,
            candidate,
            original
        })) && (yield match);
    }
}
function inKeyframes(rule) {
    return rule.parent && "atrule" === rule.parent.type && "keyframes" === rule.parent.name;
}
function generateRules(candidates, context) {
    var important, _context_candidateRuleCache_get;
    let allRules = [], strategy = !0 === (important = context.tailwindConfig.important) ? (rule)=>{
        inKeyframes(rule) || rule.walkDecls((d)=>{
            "rule" !== d.parent.type || inKeyframes(d.parent) || (d.important = !0);
        });
    } : "string" == typeof important ? (rule)=>{
        inKeyframes(rule) || (rule.selectors = rule.selectors.map((selector)=>(0, _applyImportantSelector.applyImportantSelector)(selector, important)));
    } : void 0;
    for (let candidate of candidates){
        if (context.notClassCache.has(candidate)) continue;
        if (context.candidateRuleCache.has(candidate)) {
            allRules = allRules.concat(Array.from(context.candidateRuleCache.get(candidate)));
            continue;
        }
        let matches = Array.from(resolveMatches(candidate, context));
        if (0 === matches.length) {
            context.notClassCache.add(candidate);
            continue;
        }
        context.classCache.set(candidate, matches);
        let rules = null !== (_context_candidateRuleCache_get = context.candidateRuleCache.get(candidate)) && void 0 !== _context_candidateRuleCache_get ? _context_candidateRuleCache_get : new Set();
        for (let match of (context.candidateRuleCache.set(candidate, rules), matches)){
            let [{ sort , options  }, rule] = match;
            if (options.respectImportant && strategy) {
                let container = _postcss.default.root({
                    nodes: [
                        rule.clone()
                    ]
                });
                container.walkRules(strategy), rule = container.nodes[0];
            }
            let newEntry = [
                sort,
                rule
            ];
            rules.add(newEntry), context.ruleCache.add(newEntry), allRules.push(newEntry);
        }
    }
    return allRules;
}
function isArbitraryValue(input) {
    return input.startsWith("[") && input.endsWith("]");
}
