"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: ()=>getModuleDependencies
});
const _fs = _interopRequireDefault(require("fs")), _path = _interopRequireDefault(require("path"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
let jsExtensions = [
    ".js",
    ".cjs",
    ".mjs"
], jsResolutionOrder = [
    "",
    ".js",
    ".cjs",
    ".mjs",
    ".ts",
    ".cts",
    ".mts",
    ".jsx",
    ".tsx"
], tsResolutionOrder = [
    "",
    ".ts",
    ".cts",
    ".mts",
    ".tsx",
    ".js",
    ".cjs",
    ".mjs",
    ".jsx"
];
function getModuleDependencies(absoluteFilePath) {
    return null === absoluteFilePath ? new Set() : new Set(function* _getModuleDependencies(filename, base, seen, ext = _path.default.extname(filename)) {
        let absoluteFile = function(file, extensions) {
            for (let ext of extensions){
                let full = `${file}${ext}`;
                if (_fs.default.existsSync(full) && _fs.default.statSync(full).isFile()) return full;
            }
            for (let ext1 of extensions){
                let full1 = `${file}/index${ext1}`;
                if (_fs.default.existsSync(full1)) return full1;
            }
            return null;
        }(_path.default.resolve(base, filename), jsExtensions.includes(ext) ? jsResolutionOrder : tsResolutionOrder);
        if (null === absoluteFile || seen.has(absoluteFile)) return;
        seen.add(absoluteFile), yield absoluteFile, base = _path.default.dirname(absoluteFile), ext = _path.default.extname(absoluteFile);
        let contents = _fs.default.readFileSync(absoluteFile, "utf-8");
        for (let match of [
            ...contents.matchAll(/import[\s\S]*?['"](.{3,}?)['"]/gi),
            ...contents.matchAll(/import[\s\S]*from[\s\S]*?['"](.{3,}?)['"]/gi),
            ...contents.matchAll(/require\(['"`](.+)['"`]\)/gi)
        ])match[1].startsWith(".") && (yield* _getModuleDependencies(match[1], base, seen, ext));
    }(absoluteFilePath, _path.default.dirname(absoluteFilePath), new Set()));
}
