"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: ()=>normalizeTailwindDirectives
});
const _log = function(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}(require("../util/log"));
function normalizeTailwindDirectives(root) {
    let tailwindDirectives = new Set(), layerDirectives = new Set(), applyDirectives = new Set();
    if (root.walkAtRules((atRule)=>{
        "apply" === atRule.name && applyDirectives.add(atRule), "import" === atRule.name && ('"tailwindcss/base"' === atRule.params || "'tailwindcss/base'" === atRule.params ? (atRule.name = "tailwind", atRule.params = "base") : '"tailwindcss/components"' === atRule.params || "'tailwindcss/components'" === atRule.params ? (atRule.name = "tailwind", atRule.params = "components") : '"tailwindcss/utilities"' === atRule.params || "'tailwindcss/utilities'" === atRule.params ? (atRule.name = "tailwind", atRule.params = "utilities") : ('"tailwindcss/screens"' === atRule.params || "'tailwindcss/screens'" === atRule.params || '"tailwindcss/variants"' === atRule.params || "'tailwindcss/variants'" === atRule.params) && (atRule.name = "tailwind", atRule.params = "variants")), "tailwind" === atRule.name && ("screens" === atRule.params && (atRule.params = "variants"), tailwindDirectives.add(atRule.params)), [
            "layer",
            "responsive",
            "variants"
        ].includes(atRule.name) && ([
            "responsive",
            "variants"
        ].includes(atRule.name) && _log.default.warn(`${atRule.name}-at-rule-deprecated`, [
            `The \`@${atRule.name}\` directive has been deprecated in Tailwind CSS v3.0.`,
            "Use `@layer utilities` or `@layer components` instead.",
            "https://tailwindcss.com/docs/upgrade-guide#replace-variants-with-layer"
        ]), layerDirectives.add(atRule));
    }), !tailwindDirectives.has("base") || !tailwindDirectives.has("components") || !tailwindDirectives.has("utilities")) {
        for (let rule of layerDirectives)if ("layer" === rule.name && [
            "base",
            "components",
            "utilities"
        ].includes(rule.params)) {
            if (!tailwindDirectives.has(rule.params)) throw rule.error(`\`@layer ${rule.params}\` is used but no matching \`@tailwind ${rule.params}\` directive is present.`);
        } else if ("responsive" === rule.name) {
            if (!tailwindDirectives.has("utilities")) throw rule.error("`@responsive` is used but `@tailwind utilities` is missing.");
        } else if ("variants" === rule.name && !tailwindDirectives.has("utilities")) throw rule.error("`@variants` is used but `@tailwind utilities` is missing.");
    }
    return {
        tailwindDirectives,
        applyDirectives
    };
}
