"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), function(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: !0,
        get: all[name]
    });
}(exports, {
    pattern: ()=>pattern,
    withoutCapturing: ()=>withoutCapturing,
    any: ()=>any,
    optional: ()=>optional,
    zeroOrMore: ()=>zeroOrMore,
    nestedBrackets: ()=>function nestedBrackets(open, close, depth = 1) {
            return withoutCapturing([
                escape(open),
                /[^\s]*/,
                1 === depth ? `[^${escape(open)}${escape(close)}\s]*` : any([
                    `[^${escape(open)}${escape(close)}\s]*`,
                    nestedBrackets(open, close, depth - 1)
                ]),
                /[^\s]*/,
                escape(close)
            ]);
        },
    escape: ()=>escape
});
const REGEX_SPECIAL = /[\\^$.*+?()[\]{}|]/g, REGEX_HAS_SPECIAL = RegExp(REGEX_SPECIAL.source);
function toSource(source) {
    return (source = (source = Array.isArray(source) ? source : [
        source
    ]).map((item)=>item instanceof RegExp ? item.source : item)).join("");
}
function pattern(source) {
    return RegExp(toSource(source), "g");
}
function withoutCapturing(source) {
    return RegExp(`(?:${toSource(source)})`, "g");
}
function any(sources) {
    return `(?:${sources.map(toSource).join("|")})`;
}
function optional(source) {
    return `(?:${toSource(source)})?`;
}
function zeroOrMore(source) {
    return `(?:${toSource(source)})*`;
}
function escape(string) {
    return string && REGEX_HAS_SPECIAL.test(string) ? string.replace(REGEX_SPECIAL, "\\$&") : string || "";
}
