"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), function(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: !0,
        get: all[name]
    });
}(exports, {
    elementSelectorParser: ()=>elementSelectorParser,
    default: ()=>resolveDefaultsAtRules
});
const _postcss = _interopRequireDefault(require("postcss")), _postcssSelectorParser = _interopRequireDefault(require("postcss-selector-parser")), _featureFlags = require("../featureFlags");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
let getNode = {
    id: (node)=>_postcssSelectorParser.default.attribute({
            attribute: "id",
            operator: "=",
            value: node.value,
            quoteMark: '"'
        })
}, elementSelectorParser = (0, _postcssSelectorParser.default)((selectors)=>selectors.map((s)=>(function(nodes) {
            let rest = nodes.filter((node)=>"pseudo" !== node.type || node.nodes.length > 0 || node.value.startsWith("::") || [
                    ":before",
                    ":after",
                    ":first-line",
                    ":first-letter"
                ].includes(node.value)).reverse(), searchFor = new Set([
                "tag",
                "class",
                "id",
                "attribute"
            ]), splitPointIdx = rest.findIndex((n)=>searchFor.has(n.type));
            if (-1 === splitPointIdx) return rest.reverse().join("").trim();
            let node = rest[splitPointIdx], bestNode = getNode[node.type] ? getNode[node.type](node) : node, combinatorIdx = (rest = rest.slice(0, splitPointIdx)).findIndex((n)=>"combinator" === n.type && ">" === n.value);
            return -1 !== combinatorIdx && (rest.splice(0, combinatorIdx), rest.unshift(_postcssSelectorParser.default.universal())), [
                bestNode,
                ...rest.reverse()
            ].join("").trim();
        })(s.split((n)=>"combinator" === n.type && " " === n.value).pop()))), cache = new Map();
function resolveDefaultsAtRules({ tailwindConfig  }) {
    return (root)=>{
        let variableNodeMap = new Map(), universals = new Set();
        if (root.walkAtRules("defaults", (rule)=>{
            if (rule.nodes && rule.nodes.length > 0) {
                universals.add(rule);
                return;
            }
            let variable = rule.params;
            variableNodeMap.has(variable) || variableNodeMap.set(variable, new Set()), variableNodeMap.get(variable).add(rule.parent), rule.remove();
        }), (0, _featureFlags.flagEnabled)(tailwindConfig, "optimizeUniversalDefaults")) for (let universal of universals){
            var _variableNodeMap_get, _selectorGroups_get, selector;
            let selectorGroups = new Map();
            for (let rule of null !== (_variableNodeMap_get = variableNodeMap.get(universal.params)) && void 0 !== _variableNodeMap_get ? _variableNodeMap_get : [])for (let selector1 of (selector = rule.selector, cache.has(selector) || cache.set(selector, elementSelectorParser.transformSync(selector)), cache.get(selector))){
                let selectorGroupName = selector1.includes(":-") || selector1.includes("::-") ? selector1 : "__DEFAULT__", selectors = null !== (_selectorGroups_get = selectorGroups.get(selectorGroupName)) && void 0 !== _selectorGroups_get ? _selectorGroups_get : new Set();
                selectorGroups.set(selectorGroupName, selectors), selectors.add(selector1);
            }
            if ((0, _featureFlags.flagEnabled)(tailwindConfig, "optimizeUniversalDefaults")) {
                if (0 === selectorGroups.size) {
                    universal.remove();
                    continue;
                }
                for (let [, selectors1] of selectorGroups){
                    let universalRule = _postcss.default.rule({
                        source: universal.source
                    });
                    universalRule.selectors = [
                        ...selectors1
                    ], universalRule.append(universal.nodes.map((node)=>node.clone())), universal.before(universalRule);
                }
            }
            universal.remove();
        }
        else if (universals.size) {
            let universalRule1 = _postcss.default.rule({
                selectors: [
                    "*",
                    "::before",
                    "::after"
                ]
            });
            for (let universal1 of universals)universalRule1.append(universal1.nodes), universalRule1.parent || universal1.before(universalRule1), universalRule1.source || (universalRule1.source = universal1.source), universal1.remove();
            let backdropRule = universalRule1.clone({
                selectors: [
                    "::backdrop"
                ]
            });
            universalRule1.after(backdropRule);
        }
    };
}
