"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: ()=>setupTrackingContext
});
const _fs = _interopRequireDefault(require("fs")), _quickLru = _interopRequireDefault(require("quick-lru")), _hashConfig = _interopRequireDefault(require("../util/hashConfig")), _resolveConfig = _interopRequireDefault(require("../public/resolve-config")), _resolveConfigPath = _interopRequireDefault(require("../util/resolveConfigPath")), _setupContextUtils = require("./setupContextUtils"), _parseDependency = _interopRequireDefault(require("../util/parseDependency")), _validateConfigJs = require("../util/validateConfig.js"), _contentJs = require("./content.js"), _loadConfig = require("../lib/load-config"), _getModuleDependencies = _interopRequireDefault(require("./getModuleDependencies"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
let configPathCache = new _quickLru.default({
    maxSize: 100
}), candidateFilesCache = new WeakMap();
function setupTrackingContext(configOrPath) {
    return ({ tailwindDirectives , registerDependency  })=>(root, result)=>{
            let [tailwindConfig, userConfigPath, tailwindConfigHash, configDependencies] = function(configOrPath) {
                let userConfigPath = (0, _resolveConfigPath.default)(configOrPath);
                if (null !== userConfigPath) {
                    let [prevConfig, prevConfigHash, prevDeps, prevModified] = configPathCache.get(userConfigPath) || [], newDeps = (0, _getModuleDependencies.default)(userConfigPath), modified = !1, newModified = new Map();
                    for (let file of newDeps){
                        let time = _fs.default.statSync(file).mtimeMs;
                        newModified.set(file, time), (!prevModified || !prevModified.has(file) || time > prevModified.get(file)) && (modified = !0);
                    }
                    if (!modified) return [
                        prevConfig,
                        userConfigPath,
                        prevConfigHash,
                        prevDeps
                    ];
                    for (let file1 of newDeps)delete require.cache[file1];
                    let newConfig = (0, _validateConfigJs.validateConfig)((0, _resolveConfig.default)((0, _loadConfig.loadConfig)(userConfigPath))), newHash = (0, _hashConfig.default)(newConfig);
                    return configPathCache.set(userConfigPath, [
                        newConfig,
                        newHash,
                        newDeps,
                        newModified
                    ]), [
                        newConfig,
                        userConfigPath,
                        newHash,
                        newDeps
                    ];
                }
                let newConfig1 = (0, _resolveConfig.default)(void 0 === configOrPath.config ? configOrPath : configOrPath.config);
                return [
                    newConfig1 = (0, _validateConfigJs.validateConfig)(newConfig1),
                    null,
                    (0, _hashConfig.default)(newConfig1),
                    []
                ];
            }(configOrPath), contextDependencies = new Set(configDependencies);
            if (tailwindDirectives.size > 0) for (let message of (contextDependencies.add(result.opts.from), result.messages))"dependency" === message.type && contextDependencies.add(message.file);
            let [context, , mTimesToCommit] = (0, _setupContextUtils.getContext)(root, result, tailwindConfig, userConfigPath, tailwindConfigHash, contextDependencies), fileModifiedMap = (0, _setupContextUtils.getFileModifiedMap)(context), candidateFiles = function(context, tailwindConfig) {
                if (candidateFilesCache.has(context)) return candidateFilesCache.get(context);
                let candidateFiles = (0, _contentJs.parseCandidateFiles)(context, tailwindConfig);
                return candidateFilesCache.set(context, candidateFiles).get(context);
            }(context, tailwindConfig);
            if (tailwindDirectives.size > 0) {
                for (let contentPath of candidateFiles)for (let dependency of (0, _parseDependency.default)(contentPath))registerDependency(dependency);
                let [changedContent, contentMTimesToCommit] = (0, _contentJs.resolvedChangedContent)(context, candidateFiles, fileModifiedMap);
                for (let content of changedContent)context.changedContent.push(content);
                for (let [path, mtime] of contentMTimesToCommit.entries())mTimesToCommit.set(path, mtime);
            }
            for (let file of configDependencies)registerDependency({
                type: "dependency",
                file
            });
            for (let [path1, mtime1] of mTimesToCommit.entries())fileModifiedMap.set(path1, mtime1);
            return context;
        };
}
