"use strict";
let lightningCss;
Object.defineProperty(exports, "__esModule", {
    value: !0
}), function(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: !0,
        get: all[name]
    });
}(exports, {
    lazyLightningCss: ()=>lazyLightningCss,
    lightningcss: ()=>lightningcss,
    loadPostcss: ()=>loadPostcss,
    loadPostcssImport: ()=>loadPostcssImport
});
const _packageJson = _interopRequireDefault(require("../../../../package.json")), _browserslist = _interopRequireDefault(require("browserslist")), _index = require("../../../../peers/index");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function lazyLightningCss() {
    return require("lightningcss");
}
async function lightningcss(shouldMinify, result) {
    let css = function() {
        if (lightningCss) return lightningCss;
        try {
            return lightningCss = require("lightningcss");
        } catch  {}
        return lightningCss = lazyLightningCss();
    }();
    try {
        let transformed = css.transform({
            filename: result.opts.from || "input.css",
            code: Buffer.from(result.css, "utf-8"),
            minify: shouldMinify,
            sourceMap: !!result.map,
            inputSourceMap: result.map ? result.map.toString() : void 0,
            targets: css.browserslistToTargets((0, _browserslist.default)(_packageJson.default.browserslist)),
            drafts: {
                nesting: !0
            }
        });
        return Object.assign(result, {
            css: transformed.code.toString("utf8"),
            map: result.map ? Object.assign(result.map, {
                toString: ()=>transformed.map.toString()
            }) : result.map
        });
    } catch (err) {
        return console.error("Unable to use Lightning CSS. Using raw version instead."), console.error(err), result;
    }
}
function loadPostcss() {
    try {
        return require("postcss");
    } catch  {}
    return (0, _index.lazyPostcss)();
}
function loadPostcssImport() {
    try {
        return require("postcss-import");
    } catch  {}
    return (0, _index.lazyPostcssImport)();
}
