"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "createProcessor", {
    enumerable: !0,
    get: ()=>createProcessor
});
const _path = _interopRequireDefault(require("path")), _fs = _interopRequireDefault(require("fs")), _postcssLoadConfig = _interopRequireDefault(require("postcss-load-config")), _lilconfig = require("lilconfig"), _plugins = _interopRequireDefault(require("postcss-load-config/src/plugins")), _options = _interopRequireDefault(require("postcss-load-config/src/options")), _processTailwindFeatures = _interopRequireDefault(require("../../../processTailwindFeatures")), _deps = require("./deps"), _utils = require("./utils"), _sharedState = require("../../../lib/sharedState"), _resolveConfig = _interopRequireDefault(require("../../../../resolveConfig")), _content = require("../../../lib/content"), _watching = require("./watching"), _fastGlob = _interopRequireDefault(require("fast-glob")), _findAtConfigPath = require("../../../lib/findAtConfigPath"), _log = _interopRequireDefault(require("../../../util/log")), _loadConfig = require("../../../lib/load-config"), _getModuleDependencies = _interopRequireDefault(require("../../../lib/getModuleDependencies"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
async function loadPostCssPlugins(customPostCssPath) {
    let config = customPostCssPath ? await (async ()=>{
        let file = _path.default.resolve(customPostCssPath), { config ={}  } = await (0, _lilconfig.lilconfig)("postcss").load(file);
        return (config = "function" == typeof config ? config() : Object.assign({}, config)).plugins || (config.plugins = []), {
            file,
            plugins: (0, _plugins.default)(config, file),
            options: (0, _options.default)(config, file)
        };
    })() : await (0, _postcssLoadConfig.default)(), configPlugins = config.plugins, configPluginTailwindIdx = configPlugins.findIndex((plugin)=>"function" == typeof plugin && "tailwindcss" === plugin.name || "object" == typeof plugin && null !== plugin && "tailwindcss" === plugin.postcssPlugin);
    return [
        -1 === configPluginTailwindIdx ? [] : configPlugins.slice(0, configPluginTailwindIdx),
        -1 === configPluginTailwindIdx ? configPlugins : configPlugins.slice(configPluginTailwindIdx + 1),
        config.options
    ];
}
let state = {
    context: null,
    watcher: null,
    changedContent: [],
    configBag: null,
    contextDependencies: new Set(),
    contentPaths: [],
    refreshContentPaths () {
        var _this_context;
        this.contentPaths = (0, _content.parseCandidateFiles)(this.context, null === (_this_context = this.context) || void 0 === _this_context ? void 0 : _this_context.tailwindConfig);
    },
    get config () {
        return this.context.tailwindConfig;
    },
    get contentPatterns () {
        return {
            all: this.contentPaths.map((contentPath)=>contentPath.pattern),
            dynamic: this.contentPaths.filter((contentPath)=>void 0 !== contentPath.glob).map((contentPath)=>contentPath.pattern)
        };
    },
    loadConfig (configPath, content) {
        this.watcher && configPath && this.refreshConfigDependencies();
        let config = (0, _loadConfig.loadConfig)(configPath), dependencies = (0, _getModuleDependencies.default)(configPath);
        return this.configBag = {
            config,
            dependencies,
            dispose () {
                for (let file of dependencies)delete require.cache[require.resolve(file)];
            }
        }, this.configBag.config = (0, _resolveConfig.default)(this.configBag.config, {
            content: {
                files: []
            }
        }), (null == content ? void 0 : content.length) > 0 && (this.configBag.config.content.files = content), this.configBag.config;
    },
    refreshConfigDependencies (configPath) {
        var _this_configBag;
        _sharedState.env.DEBUG && console.time("Module dependencies"), null === (_this_configBag = this.configBag) || void 0 === _this_configBag || _this_configBag.dispose(), _sharedState.env.DEBUG && console.timeEnd("Module dependencies");
    },
    readContentPaths () {
        let content = [];
        for (let file of _fastGlob.default.sync(this.contentPatterns.all))content.push({
            content: _fs.default.readFileSync(_path.default.resolve(file), "utf8"),
            extension: _path.default.extname(file).slice(1)
        });
        for (let { raw: htmlContent , extension ="html"  } of this.config.content.files.filter((file)=>null !== file && "object" == typeof file))content.push({
            content: htmlContent,
            extension
        });
        return content;
    },
    getContext ({ createContext , cliConfigPath , root , result , content  }) {
        var _findAtConfigPath1;
        if (this.context) return this.context.changedContent = this.changedContent.splice(0), this.context;
        _sharedState.env.DEBUG && console.time("Searching for config");
        let configPath = null !== (_findAtConfigPath1 = (0, _findAtConfigPath.findAtConfigPath)(root, result)) && void 0 !== _findAtConfigPath1 ? _findAtConfigPath1 : cliConfigPath;
        _sharedState.env.DEBUG && console.timeEnd("Searching for config"), _sharedState.env.DEBUG && console.time("Loading config");
        let config = this.loadConfig(configPath, content);
        for (let file of (_sharedState.env.DEBUG && console.timeEnd("Loading config"), _sharedState.env.DEBUG && console.time("Creating context"), this.context = createContext(config, []), Object.assign(this.context, {
            userConfigPath: configPath
        }), _sharedState.env.DEBUG && console.timeEnd("Creating context"), _sharedState.env.DEBUG && console.time("Resolving content paths"), this.refreshContentPaths(), _sharedState.env.DEBUG && console.timeEnd("Resolving content paths"), this.watcher && (_sharedState.env.DEBUG && console.time("Watch new files"), this.watcher.refreshWatchedFiles(), _sharedState.env.DEBUG && console.timeEnd("Watch new files")), this.readContentPaths()))this.context.changedContent.push(file);
        return this.context;
    }
};
async function createProcessor(args, cliConfigPath) {
    var _args_content, _args_content_split;
    let postcss, IMPORT_COMMENT;
    let postcss1 = (0, _deps.loadPostcss)(), input = args["--input"], output = args["--output"], includePostCss = args["--postcss"], customPostCssPath = "string" == typeof args["--postcss"] ? args["--postcss"] : void 0, [beforePlugins, afterPlugins, postcssOptions] = includePostCss ? await loadPostCssPlugins(customPostCssPath) : (postcss = (0, _deps.loadPostcss)(), IMPORT_COMMENT = "__TAILWIND_RESTORE_IMPORT__: ", [
        [
            (root)=>{
                root.walkAtRules("import", (rule)=>{
                    rule.params.slice(1).startsWith("tailwindcss/") && (rule.after(postcss.comment({
                        text: IMPORT_COMMENT + rule.params
                    })), rule.remove());
                });
            },
            (0, _deps.loadPostcssImport)(),
            (root)=>{
                root.walkComments((rule)=>{
                    rule.text.startsWith(IMPORT_COMMENT) && (rule.after(postcss.atRule({
                        name: "import",
                        params: rule.text.replace(IMPORT_COMMENT, "")
                    })), rule.remove());
                });
            }
        ],
        [],
        {}
    ]);
    args["--purge"] && (_log.default.warn("purge-flag-deprecated", [
        "The `--purge` flag has been deprecated.",
        "Please use `--content` instead."
    ]), args["--content"] || (args["--content"] = args["--purge"]));
    let content = null !== (_args_content_split = null === (_args_content = args["--content"]) || void 0 === _args_content ? void 0 : _args_content.split(/(?<!{[^}]+),/)) && void 0 !== _args_content_split ? _args_content_split : [], tailwindPlugin = ()=>({
            postcssPlugin: "tailwindcss",
            Once (root, { result  }) {
                _sharedState.env.DEBUG && console.time("Compiling CSS"), (0, _processTailwindFeatures.default)(({ createContext  })=>(console.error(), console.error("Rebuilding..."), ()=>state.getContext({
                            createContext,
                            cliConfigPath,
                            root,
                            result,
                            content
                        })))(root, result), _sharedState.env.DEBUG && console.timeEnd("Compiling CSS");
            }
        });
    tailwindPlugin.postcss = !0;
    let processor = postcss1([
        ...beforePlugins,
        tailwindPlugin,
        !args["--minify"] && _utils.formatNodes,
        ...afterPlugins
    ].filter(Boolean));
    async function readInput() {
        return "-" === input ? (0, _utils.drainStdin)() : input ? _fs.default.promises.readFile(_path.default.resolve(input), "utf8") : "@tailwind base; @tailwind components; @tailwind utilities";
    }
    async function build() {
        let start = process.hrtime.bigint();
        return readInput().then((css)=>processor.process(css, {
                ...postcssOptions,
                from: input,
                to: output
            })).then((result)=>(0, _deps.lightningcss)(!!args["--minify"], result)).then((result)=>{
            if (!state.watcher) return result;
            for (let message of (_sharedState.env.DEBUG && console.time("Recording PostCSS dependencies"), result.messages))"dependency" === message.type && state.contextDependencies.add(message.file);
            return _sharedState.env.DEBUG && console.timeEnd("Recording PostCSS dependencies"), _sharedState.env.DEBUG && console.time("Watch new files"), state.watcher.refreshWatchedFiles(), _sharedState.env.DEBUG && console.timeEnd("Watch new files"), result;
        }).then((result)=>{
            if (!output) {
                process.stdout.write(result.css);
                return;
            }
            return Promise.all([
                (0, _utils.outputFile)(result.opts.to, result.css),
                result.map && (0, _utils.outputFile)(result.opts.to + ".map", result.map.toString())
            ]);
        }).then(()=>{
            let end = process.hrtime.bigint();
            console.error(), console.error("Done in", (end - start) / BigInt(1e6) + "ms.");
        }).then(()=>{}, (err)=>{
            if (!state.watcher) return Promise.reject(err);
            console.error(err);
        });
    }
    async function parseChanges(changes) {
        return Promise.all(changes.map(async (change)=>({
                content: await change.content(),
                extension: change.extension
            })));
    }
    return void 0 !== input && "-" !== input && state.contextDependencies.add(_path.default.resolve(input)), {
        build,
        watch: async ()=>{
            state.watcher = (0, _watching.createWatcher)(args, {
                state,
                async rebuild (changes) {
                    if (changes.some((change)=>{
                        var _state_configBag;
                        return (null === (_state_configBag = state.configBag) || void 0 === _state_configBag ? void 0 : _state_configBag.dependencies.has(change.file)) || state.contextDependencies.has(change.file);
                    })) state.context = null;
                    else for (let change of (await parseChanges(changes)))state.changedContent.push(change);
                    return build();
                }
            }), await build();
        }
    };
}
