"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "createWatcher", {
    enumerable: !0,
    get: ()=>createWatcher
});
const _chokidar = _interopRequireDefault(require("chokidar")), _fs = _interopRequireDefault(require("fs")), _micromatch = _interopRequireDefault(require("micromatch")), _normalizePath = _interopRequireDefault(require("normalize-path")), _path = _interopRequireDefault(require("path")), _utils = require("./utils");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function createWatcher(args, { state , rebuild  }) {
    let _timer, _reject, shouldPoll = args["--poll"], shouldCoalesceWriteEvents = shouldPoll || "win32" === process.platform, watcher = _chokidar.default.watch([], {
        atomic: !0,
        usePolling: shouldPoll,
        interval: shouldPoll ? 10 : void 0,
        ignoreInitial: !0,
        awaitWriteFinish: !!shouldCoalesceWriteEvents && {
            stabilityThreshold: 50,
            pollInterval: 10
        }
    }), chain = Promise.resolve(), changedContent = [], pendingRebuilds = new Set();
    async function rebuildAndContinue() {
        let changes = changedContent.splice(0);
        return 0 === changes.length ? Promise.resolve() : (changes.forEach((change)=>pendingRebuilds.delete(change.file)), rebuild(changes).then(()=>{}, ()=>{}));
    }
    function recordChangedFile(file, content = null, skipPendingCheck = !1) {
        return (file = _path.default.resolve(file), pendingRebuilds.has(file) && !skipPendingCheck) ? Promise.resolve() : (pendingRebuilds.add(file), changedContent.push({
            file,
            content: null != content ? content : ()=>_fs.default.promises.readFile(file, "utf8"),
            extension: _path.default.extname(file).slice(1)
        }), _timer && (clearTimeout(_timer), _reject()), chain = (chain = chain.then(()=>new Promise((resolve, reject)=>{
                _timer = setTimeout(resolve, 10), _reject = reject;
            }))).then(rebuildAndContinue, rebuildAndContinue));
    }
    return watcher.on("change", (file)=>recordChangedFile(file)), watcher.on("add", (file)=>recordChangedFile(file)), watcher.on("unlink", (file)=>{
        file = (0, _normalizePath.default)(file), _micromatch.default.some([
            file
        ], state.contentPatterns.dynamic) || watcher.add(file);
    }), watcher.on("raw", (evt, filePath, meta)=>{
        if ("rename" !== evt) return;
        let watchedPath = meta.watchedPath;
        async function enqueue() {
            try {
                let content = await (0, _utils.readFileWithRetries)(_path.default.resolve(filePath));
                if (void 0 === content) return;
                await recordChangedFile(filePath, ()=>content, !0);
            } catch  {}
        }
        filePath = watchedPath.endsWith(filePath) ? watchedPath : _path.default.join(watchedPath, filePath), _micromatch.default.some([
            filePath
        ], state.contentPatterns.all) && (pendingRebuilds.has(filePath) || (pendingRebuilds.add(filePath), enqueue().then(()=>{
            pendingRebuilds.delete(filePath);
        })));
    }), {
        fswatcher: watcher,
        refreshWatchedFiles () {
            watcher.add(Array.from(state.contextDependencies)), watcher.add(Array.from(state.configBag.dependencies)), watcher.add(state.contentPatterns.all);
        }
    };
}
