"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: ()=>processTailwindFeatures
});
const _normalizeTailwindDirectives = _interopRequireDefault(require("./lib/normalizeTailwindDirectives")), _expandTailwindAtRules = _interopRequireDefault(require("./lib/expandTailwindAtRules")), _expandApplyAtRules = _interopRequireDefault(require("./lib/expandApplyAtRules")), _evaluateTailwindFunctions = _interopRequireDefault(require("./lib/evaluateTailwindFunctions")), _substituteScreenAtRules = _interopRequireDefault(require("./lib/substituteScreenAtRules")), _resolveDefaultsAtRules = _interopRequireDefault(require("./lib/resolveDefaultsAtRules")), _collapseAdjacentRules = _interopRequireDefault(require("./lib/collapseAdjacentRules")), _collapseDuplicateDeclarations = _interopRequireDefault(require("./lib/collapseDuplicateDeclarations")), _partitionApplyAtRules = _interopRequireDefault(require("./lib/partitionApplyAtRules")), _detectNesting = _interopRequireDefault(require("./lib/detectNesting")), _setupContextUtils = require("./lib/setupContextUtils"), _featureFlags = require("./featureFlags");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function processTailwindFeatures(setupContext) {
    return function(root, result) {
        let { tailwindDirectives , applyDirectives  } = (0, _normalizeTailwindDirectives.default)(root);
        (0, _detectNesting.default)()(root, result), (0, _partitionApplyAtRules.default)()(root, result);
        let context = setupContext({
            tailwindDirectives,
            applyDirectives,
            registerDependency (dependency) {
                result.messages.push({
                    plugin: "tailwindcss",
                    parent: result.opts.from,
                    ...dependency
                });
            },
            createContext: (tailwindConfig, changedContent)=>(0, _setupContextUtils.createContext)(tailwindConfig, changedContent, root)
        })(root, result);
        if ("-" === context.tailwindConfig.separator) throw Error("The '-' character cannot be used as a custom separator in JIT mode due to parsing ambiguity. Please use another character like '_' instead.");
        (0, _featureFlags.issueFlagNotices)(context.tailwindConfig), (0, _expandTailwindAtRules.default)(context)(root, result), (0, _partitionApplyAtRules.default)()(root, result), (0, _expandApplyAtRules.default)(context)(root, result), (0, _evaluateTailwindFunctions.default)(context)(root, result), (0, _substituteScreenAtRules.default)(context)(root, result), (0, _resolveDefaultsAtRules.default)(context)(root, result), (0, _collapseAdjacentRules.default)(context)(root, result), (0, _collapseDuplicateDeclarations.default)(context)(root, result);
    };
}
