"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), function(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: !0,
        get: all[name]
    });
}(exports, {
    parseColor: ()=>parseColor,
    formatColor: ()=>formatColor
});
const _colorName = function(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}(require("color-name"));
let HEX = /^#([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})?$/i, SHORT_HEX = /^#([a-f\d])([a-f\d])([a-f\d])([a-f\d])?$/i, VALUE = /(?:\d+|\d*\.\d+)%?/, SEP = /(?:\s*,\s*|\s+)/, ALPHA_SEP = /\s*[,/]\s*/, CUSTOM_PROPERTY = /var\(--(?:[^ )]*?)\)/, RGB = RegExp(`^(rgba?)\\(\\s*(${VALUE.source}|${CUSTOM_PROPERTY.source})(?:${SEP.source}(${VALUE.source}|${CUSTOM_PROPERTY.source}))?(?:${SEP.source}(${VALUE.source}|${CUSTOM_PROPERTY.source}))?(?:${ALPHA_SEP.source}(${VALUE.source}|${CUSTOM_PROPERTY.source}))?\\s*\\)$`), HSL = RegExp(`^(hsla?)\\(\\s*((?:${VALUE.source})(?:deg|rad|grad|turn)?|${CUSTOM_PROPERTY.source})(?:${SEP.source}(${VALUE.source}|${CUSTOM_PROPERTY.source}))?(?:${SEP.source}(${VALUE.source}|${CUSTOM_PROPERTY.source}))?(?:${ALPHA_SEP.source}(${VALUE.source}|${CUSTOM_PROPERTY.source}))?\\s*\\)$`);
function parseColor(value, { loose =!1  } = {}) {
    var _match_, _match__toString, _value_match;
    if ("string" != typeof value) return null;
    if ("transparent" === (value = value.trim())) return {
        mode: "rgb",
        color: [
            "0",
            "0",
            "0"
        ],
        alpha: "0"
    };
    if (value in _colorName.default) return {
        mode: "rgb",
        color: _colorName.default[value].map((v)=>v.toString())
    };
    let hex = value.replace(SHORT_HEX, (_, r, g, b, a)=>[
            "#",
            r,
            r,
            g,
            g,
            b,
            b,
            a ? a + a : ""
        ].join("")).match(HEX);
    if (null !== hex) return {
        mode: "rgb",
        color: [
            parseInt(hex[1], 16),
            parseInt(hex[2], 16),
            parseInt(hex[3], 16)
        ].map((v)=>v.toString()),
        alpha: hex[4] ? (parseInt(hex[4], 16) / 255).toString() : void 0
    };
    let match = null !== (_value_match = value.match(RGB)) && void 0 !== _value_match ? _value_match : value.match(HSL);
    if (null === match) return null;
    let color = [
        match[2],
        match[3],
        match[4]
    ].filter(Boolean).map((v)=>v.toString());
    return 2 === color.length && color[0].startsWith("var(") ? {
        mode: match[1],
        color: [
            color[0]
        ],
        alpha: color[1]
    } : (loose || 3 === color.length) && (!(color.length < 3) || color.some((part)=>/^var\(.*?\)$/.test(part))) ? {
        mode: match[1],
        color,
        alpha: null === (_match_ = match[5]) || void 0 === _match_ ? void 0 : null === (_match__toString = _match_.toString) || void 0 === _match__toString ? void 0 : _match__toString.call(_match_)
    } : null;
}
function formatColor({ mode , color , alpha  }) {
    let hasAlpha = void 0 !== alpha;
    return "rgba" === mode || "hsla" === mode ? `${mode}(${color.join(", ")}${hasAlpha ? `, ${alpha}` : ""})` : `${mode}(${color.join(" ")}${hasAlpha ? ` / ${alpha}` : ""})`;
}
