"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), function(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: !0,
        get: all[name]
    });
}(exports, {
    formatVariantSelector: ()=>formatVariantSelector,
    eliminateIrrelevantSelectors: ()=>eliminateIrrelevantSelectors,
    finalizeSelector: ()=>finalizeSelector,
    handleMergePseudo: ()=>handleMergePseudo
});
const _postcssSelectorParser = _interopRequireDefault(require("postcss-selector-parser")), _unesc = _interopRequireDefault(require("postcss-selector-parser/dist/util/unesc")), _escapeClassName = _interopRequireDefault(require("../util/escapeClassName")), _prefixSelector = _interopRequireDefault(require("../util/prefixSelector")), _pseudoElements = require("./pseudoElements");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
let MERGE = ":merge";
function formatVariantSelector(formats, { context , candidate  }) {
    var _context_tailwindConfig_prefix;
    let prefix = null !== (_context_tailwindConfig_prefix = null == context ? void 0 : context.tailwindConfig.prefix) && void 0 !== _context_tailwindConfig_prefix ? _context_tailwindConfig_prefix : "", parsedFormats = formats.map((format)=>{
        let ast = (0, _postcssSelectorParser.default)().astSync(format.format);
        return {
            ...format,
            ast: format.isArbitraryVariant ? ast : (0, _prefixSelector.default)(prefix, ast)
        };
    }), formatAst = _postcssSelectorParser.default.root({
        nodes: [
            _postcssSelectorParser.default.selector({
                nodes: [
                    _postcssSelectorParser.default.className({
                        value: (0, _escapeClassName.default)(candidate)
                    })
                ]
            })
        ]
    });
    for (let { ast  } of parsedFormats)[formatAst, ast] = handleMergePseudo(formatAst, ast), ast.walkNesting((nesting)=>nesting.replaceWith(...formatAst.nodes[0].nodes)), formatAst = ast;
    return formatAst;
}
function simpleSelectorForNode(node) {
    let nodes = [];
    for(; node.prev() && "combinator" !== node.prev().type;)node = node.prev();
    for(; node && "combinator" !== node.type;)nodes.push(node), node = node.next();
    return nodes;
}
function eliminateIrrelevantSelectors(sel, base) {
    let hasClassesMatchingCandidate = !1;
    sel.walk((child)=>{
        if ("class" === child.type && child.value === base) return hasClassesMatchingCandidate = !0, !1;
    }), hasClassesMatchingCandidate || sel.remove();
}
function finalizeSelector(current, formats, { context , candidate , base  }) {
    var _context_tailwindConfig, _context_tailwindConfig_separator;
    let separator = null !== (_context_tailwindConfig_separator = null == context ? void 0 : null === (_context_tailwindConfig = context.tailwindConfig) || void 0 === _context_tailwindConfig ? void 0 : _context_tailwindConfig.separator) && void 0 !== _context_tailwindConfig_separator ? _context_tailwindConfig_separator : ":";
    base = null != base ? base : candidate.split(RegExp(`\\${separator}(?![^[]*\\])`)).pop();
    let selector = (0, _postcssSelectorParser.default)().astSync(current);
    selector.walkClasses((node)=>{
        node.raws && node.value.includes(base) && (node.raws.value = (0, _escapeClassName.default)((0, _unesc.default)(node.raws.value)));
    }), selector.each((sel)=>eliminateIrrelevantSelectors(sel, base));
    let formatAst = Array.isArray(formats) ? formatVariantSelector(formats, {
        context,
        candidate
    }) : formats;
    if (null === formatAst) return selector.toString();
    let simpleStart = _postcssSelectorParser.default.comment({
        value: "/*__simple__*/"
    }), simpleEnd = _postcssSelectorParser.default.comment({
        value: "/*__simple__*/"
    });
    return selector.walkClasses((node)=>{
        var sel;
        if (node.value !== base) return;
        let parent = node.parent, formatNodes = formatAst.nodes[0].nodes;
        if (1 === parent.nodes.length) {
            node.replaceWith(...formatNodes);
            return;
        }
        let simpleSelector = simpleSelectorForNode(node);
        for (let child of (parent.insertBefore(simpleSelector[0], simpleStart), parent.insertAfter(simpleSelector[simpleSelector.length - 1], simpleEnd), formatNodes))parent.insertBefore(simpleSelector[0], child.clone());
        node.remove(), simpleSelector = simpleSelectorForNode(simpleStart);
        let firstNode = parent.index(simpleStart);
        parent.nodes.splice(firstNode, simpleSelector.length, ...((sel = _postcssSelectorParser.default.selector({
            nodes: simpleSelector
        })).sort((a, b)=>"tag" === a.type && "class" === b.type ? -1 : "class" === a.type && "tag" === b.type ? 1 : "class" === a.type && "pseudo" === b.type && b.value.startsWith("::") ? -1 : "pseudo" === a.type && a.value.startsWith("::") && "class" === b.type ? 1 : sel.index(a) - sel.index(b)), sel).nodes), simpleStart.remove(), simpleEnd.remove();
    }), selector.walkPseudos((p)=>{
        p.value === MERGE && p.replaceWith(p.nodes);
    }), selector.each((sel)=>(0, _pseudoElements.movePseudos)(sel)), selector.toString();
}
function handleMergePseudo(selector, format) {
    let merges = [];
    return selector.walkPseudos((pseudo)=>{
        pseudo.value === MERGE && merges.push({
            pseudo,
            value: pseudo.nodes[0].toString()
        });
    }), format.walkPseudos((pseudo)=>{
        if (pseudo.value !== MERGE) return;
        let value = pseudo.nodes[0].toString(), existing = merges.find((merge)=>merge.value === value);
        if (!existing) return;
        let attachments = [], next = pseudo.next();
        for(; next && "combinator" !== next.type;)attachments.push(next), next = next.next();
        let combinator = next;
        existing.pseudo.parent.insertAfter(existing.pseudo, _postcssSelectorParser.default.selector({
            nodes: attachments.map((node)=>node.clone())
        })), pseudo.remove(), attachments.forEach((node)=>node.remove()), combinator && "combinator" === combinator.type && combinator.remove();
    }), [
        selector,
        format
    ];
}
