"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "normalizeConfig", {
    enumerable: !0,
    get: ()=>normalizeConfig
});
const _featureFlags = require("../featureFlags"), _log = function(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) return obj;
    if (null === obj || "object" != typeof obj && "function" != typeof obj) return {
        default: obj
    };
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) return cache.get(obj);
    var newObj = {}, hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj)if ("default" !== key && Object.prototype.hasOwnProperty.call(obj, key)) {
        var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
        desc && (desc.get || desc.set) ? Object.defineProperty(newObj, key, desc) : newObj[key] = obj[key];
    }
    return newObj.default = obj, cache && cache.set(obj, newObj), newObj;
}(require("./log"));
function _getRequireWildcardCache(nodeInterop) {
    if ("function" != typeof WeakMap) return null;
    var cacheBabelInterop = new WeakMap(), cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function normalizeConfig(config) {
    var _config_prefix, _config_purge, _config_content, _config_purge1, _config_purge_transform, _config_content1, _config_content_transform;
    let transform, transformers;
    for (let file of ((()=>{
        if (config.purge || !config.content || !Array.isArray(config.content) && !("object" == typeof config.content && null !== config.content)) return !1;
        if (Array.isArray(config.content)) return config.content.every((path)=>"string" == typeof path || "string" == typeof (null == path ? void 0 : path.raw) && (null == path || !path.extension || "string" == typeof (null == path ? void 0 : path.extension)));
        if ("object" == typeof config.content && null !== config.content) {
            if (Object.keys(config.content).some((key)=>![
                    "files",
                    "relative",
                    "extract",
                    "transform"
                ].includes(key))) return !1;
            if (Array.isArray(config.content.files)) {
                if (!config.content.files.every((path)=>"string" == typeof path || "string" == typeof (null == path ? void 0 : path.raw) && (null == path || !path.extension || "string" == typeof (null == path ? void 0 : path.extension)))) return !1;
                if ("object" == typeof config.content.extract) {
                    for (let value of Object.values(config.content.extract))if ("function" != typeof value) return !1;
                } else if (!(void 0 === config.content.extract || "function" == typeof config.content.extract)) return !1;
                if ("object" == typeof config.content.transform) {
                    for (let value1 of Object.values(config.content.transform))if ("function" != typeof value1) return !1;
                } else if (!(void 0 === config.content.transform || "function" == typeof config.content.transform)) return !1;
                if ("boolean" != typeof config.content.relative && void 0 !== config.content.relative) return !1;
            }
            return !0;
        }
        return !1;
    })() || _log.default.warn("purge-deprecation", [
        "The `purge`/`content` options have changed in Tailwind CSS v3.0.",
        "Update your configuration file to eliminate this warning.",
        "https://tailwindcss.com/docs/upgrade-guide#configure-content-sources"
    ]), config.safelist = (()=>{
        var _purge_options;
        let { content , purge , safelist  } = config;
        return Array.isArray(safelist) ? safelist : Array.isArray(null == content ? void 0 : content.safelist) ? content.safelist : Array.isArray(null == purge ? void 0 : purge.safelist) ? purge.safelist : Array.isArray(null == purge ? void 0 : null === (_purge_options = purge.options) || void 0 === _purge_options ? void 0 : _purge_options.safelist) ? purge.options.safelist : [];
    })(), config.blocklist = (()=>{
        let { blocklist  } = config;
        if (Array.isArray(blocklist)) {
            if (blocklist.every((item)=>"string" == typeof item)) return blocklist;
            _log.default.warn("blocklist-invalid", [
                "The `blocklist` option must be an array of strings.",
                "https://tailwindcss.com/docs/content-configuration#discarding-classes"
            ]);
        }
        return [];
    })(), "function" == typeof config.prefix ? (_log.default.warn("prefix-function", [
        "As of Tailwind CSS v3.0, `prefix` cannot be a function.",
        "Update `prefix` in your configuration to be a string to eliminate this warning.",
        "https://tailwindcss.com/docs/upgrade-guide#prefix-cannot-be-a-function"
    ]), config.prefix = "") : config.prefix = null !== (_config_prefix = config.prefix) && void 0 !== _config_prefix ? _config_prefix : "", config.content = {
        relative: (()=>{
            let { content  } = config;
            return (null == content ? void 0 : content.relative) ? content.relative : (0, _featureFlags.flagEnabled)(config, "relativeContentPathsByDefault");
        })(),
        files: (()=>{
            let { content , purge  } = config;
            return Array.isArray(purge) ? purge : Array.isArray(null == purge ? void 0 : purge.content) ? purge.content : Array.isArray(content) ? content : Array.isArray(null == content ? void 0 : content.content) ? content.content : Array.isArray(null == content ? void 0 : content.files) ? content.files : [];
        })(),
        extract: (()=>{
            var _config_purge, _config_content, _config_purge1, _config_purge_extract, _config_content1, _config_content_extract, _config_purge2, _config_purge_options, _config_content2, _config_content_options, _config_purge3, _config_purge_options1, _config_content3, _config_content_options1;
            let extract = (null === (_config_purge = config.purge) || void 0 === _config_purge ? void 0 : _config_purge.extract) ? config.purge.extract : (null === (_config_content = config.content) || void 0 === _config_content ? void 0 : _config_content.extract) ? config.content.extract : (null === (_config_purge1 = config.purge) || void 0 === _config_purge1 ? void 0 : null === (_config_purge_extract = _config_purge1.extract) || void 0 === _config_purge_extract ? void 0 : _config_purge_extract.DEFAULT) ? config.purge.extract.DEFAULT : (null === (_config_content1 = config.content) || void 0 === _config_content1 ? void 0 : null === (_config_content_extract = _config_content1.extract) || void 0 === _config_content_extract ? void 0 : _config_content_extract.DEFAULT) ? config.content.extract.DEFAULT : (null === (_config_purge2 = config.purge) || void 0 === _config_purge2 ? void 0 : null === (_config_purge_options = _config_purge2.options) || void 0 === _config_purge_options ? void 0 : _config_purge_options.extractors) ? config.purge.options.extractors : (null === (_config_content2 = config.content) || void 0 === _config_content2 ? void 0 : null === (_config_content_options = _config_content2.options) || void 0 === _config_content_options ? void 0 : _config_content_options.extractors) ? config.content.options.extractors : {}, extractors = {}, defaultExtractor = (null === (_config_purge3 = config.purge) || void 0 === _config_purge3 ? void 0 : null === (_config_purge_options1 = _config_purge3.options) || void 0 === _config_purge_options1 ? void 0 : _config_purge_options1.defaultExtractor) ? config.purge.options.defaultExtractor : (null === (_config_content3 = config.content) || void 0 === _config_content3 ? void 0 : null === (_config_content_options1 = _config_content3.options) || void 0 === _config_content_options1 ? void 0 : _config_content_options1.defaultExtractor) ? config.content.options.defaultExtractor : void 0;
            if (void 0 !== defaultExtractor && (extractors.DEFAULT = defaultExtractor), "function" == typeof extract) extractors.DEFAULT = extract;
            else if (Array.isArray(extract)) for (let { extensions , extractor  } of null != extract ? extract : [])for (let extension of extensions)extractors[extension] = extractor;
            else "object" == typeof extract && null !== extract && Object.assign(extractors, extract);
            return extractors;
        })(),
        transform: (transform = (null === (_config_purge = config.purge) || void 0 === _config_purge ? void 0 : _config_purge.transform) ? config.purge.transform : (null === (_config_content = config.content) || void 0 === _config_content ? void 0 : _config_content.transform) ? config.content.transform : (null === (_config_purge1 = config.purge) || void 0 === _config_purge1 ? void 0 : null === (_config_purge_transform = _config_purge1.transform) || void 0 === _config_purge_transform ? void 0 : _config_purge_transform.DEFAULT) ? config.purge.transform.DEFAULT : (null === (_config_content1 = config.content) || void 0 === _config_content1 ? void 0 : null === (_config_content_transform = _config_content1.transform) || void 0 === _config_content_transform ? void 0 : _config_content_transform.DEFAULT) ? config.content.transform.DEFAULT : {}, transformers = {}, "function" == typeof transform && (transformers.DEFAULT = transform), "object" == typeof transform && null !== transform && Object.assign(transformers, transform), transformers)
    }, config.content.files))if ("string" == typeof file && /{([^,]*?)}/g.test(file)) {
        _log.default.warn("invalid-glob-braces", [
            `The glob pattern ${(0, _log.dim)(file)} in your Tailwind CSS configuration is invalid.`,
            `Update it to ${(0, _log.dim)(file.replace(/{([^,]*?)}/g, "$1"))} to silence this warning.`
        ]);
        break;
    }
    return config;
}
