"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: ()=>parseAnimationValue
});
const DIRECTIONS = new Set([
    "normal",
    "reverse",
    "alternate",
    "alternate-reverse"
]), PLAY_STATES = new Set([
    "running",
    "paused"
]), FILL_MODES = new Set([
    "none",
    "forwards",
    "backwards",
    "both"
]), ITERATION_COUNTS = new Set([
    "infinite"
]), TIMINGS = new Set([
    "linear",
    "ease",
    "ease-in",
    "ease-out",
    "ease-in-out",
    "step-start",
    "step-end"
]), TIMING_FNS = [
    "cubic-bezier",
    "steps"
], COMMA = /\,(?![^(]*\))/g, SPACE = /\ +(?![^(]*\))/g, TIME = /^(-?[\d.]+m?s)$/, DIGIT = /^(\d+)$/;
function parseAnimationValue(input) {
    return input.split(COMMA).map((animation)=>{
        let value = animation.trim(), result = {
            value
        }, parts = value.split(SPACE), seen = new Set();
        for (let part of parts)!seen.has("DIRECTIONS") && DIRECTIONS.has(part) ? (result.direction = part, seen.add("DIRECTIONS")) : !seen.has("PLAY_STATES") && PLAY_STATES.has(part) ? (result.playState = part, seen.add("PLAY_STATES")) : !seen.has("FILL_MODES") && FILL_MODES.has(part) ? (result.fillMode = part, seen.add("FILL_MODES")) : !seen.has("ITERATION_COUNTS") && (ITERATION_COUNTS.has(part) || DIGIT.test(part)) ? (result.iterationCount = part, seen.add("ITERATION_COUNTS")) : !seen.has("TIMING_FUNCTION") && TIMINGS.has(part) ? (result.timingFunction = part, seen.add("TIMING_FUNCTION")) : !seen.has("TIMING_FUNCTION") && TIMING_FNS.some((f)=>part.startsWith(`${f}(`)) ? (result.timingFunction = part, seen.add("TIMING_FUNCTION")) : !seen.has("DURATION") && TIME.test(part) ? (result.duration = part, seen.add("DURATION")) : !seen.has("DELAY") && TIME.test(part) ? (result.delay = part, seen.add("DELAY")) : seen.has("NAME") ? (result.unknown || (result.unknown = []), result.unknown.push(part)) : (result.name = part, seen.add("NAME"));
        return result;
    });
}
