"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), function(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: !0,
        get: all[name]
    });
}(exports, {
    parseBoxShadowValue: ()=>parseBoxShadowValue,
    formatBoxShadowValue: ()=>formatBoxShadowValue
});
const _splitAtTopLevelOnly = require("./splitAtTopLevelOnly");
let KEYWORDS = new Set([
    "inset",
    "inherit",
    "initial",
    "revert",
    "unset"
]), SPACE = /\ +(?![^(]*\))/g, LENGTH = /^-?(\d+|\.\d+)(.*?)$/g;
function parseBoxShadowValue(input) {
    return (0, _splitAtTopLevelOnly.splitAtTopLevelOnly)(input, ",").map((shadow)=>{
        let value = shadow.trim(), result = {
            raw: value
        }, parts = value.split(SPACE), seen = new Set();
        for (let part of parts)LENGTH.lastIndex = 0, !seen.has("KEYWORD") && KEYWORDS.has(part) ? (result.keyword = part, seen.add("KEYWORD")) : LENGTH.test(part) ? seen.has("X") ? seen.has("Y") ? seen.has("BLUR") ? seen.has("SPREAD") || (result.spread = part, seen.add("SPREAD")) : (result.blur = part, seen.add("BLUR")) : (result.y = part, seen.add("Y")) : (result.x = part, seen.add("X")) : result.color ? (result.unknown || (result.unknown = []), result.unknown.push(part)) : result.color = part;
        return result.valid = void 0 !== result.x && void 0 !== result.y, result;
    });
}
function formatBoxShadowValue(shadows) {
    return shadows.map((shadow)=>shadow.valid ? [
            shadow.keyword,
            shadow.x,
            shadow.y,
            shadow.blur,
            shadow.spread,
            shadow.color
        ].filter(Boolean).join(" ") : shadow.raw).join(", ");
}
