"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "default", {
    enumerable: !0,
    get: ()=>resolveConfig
});
const _negateValue = _interopRequireDefault(require("./negateValue")), _corePluginList = _interopRequireDefault(require("../corePluginList")), _configurePlugins = _interopRequireDefault(require("./configurePlugins")), _colors = _interopRequireDefault(require("../public/colors")), _defaults = require("./defaults"), _toPath = require("./toPath"), _normalizeConfig = require("./normalizeConfig"), _isPlainObject = _interopRequireDefault(require("./isPlainObject")), _cloneDeep = require("./cloneDeep"), _pluginUtils = require("./pluginUtils"), _withAlphaVariable = require("./withAlphaVariable"), _toColorValue = _interopRequireDefault(require("./toColorValue"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function isFunction(input) {
    return "function" == typeof input;
}
function mergeWith(target, ...sources) {
    let customizer = sources.pop();
    for (let source of sources)for(let k in source){
        let merged = customizer(target[k], source[k]);
        void 0 === merged ? (0, _isPlainObject.default)(target[k]) && (0, _isPlainObject.default)(source[k]) ? target[k] = mergeWith({}, target[k], source[k], customizer) : target[k] = source[k] : target[k] = merged;
    }
    return target;
}
const configUtils = {
    colors: _colors.default,
    negative: (scale)=>Object.keys(scale).filter((key)=>"0" !== scale[key]).reduce((negativeScale, key)=>{
            let negativeValue = (0, _negateValue.default)(scale[key]);
            return void 0 !== negativeValue && (negativeScale[`-${key}`] = negativeValue), negativeScale;
        }, {}),
    breakpoints: (screens)=>Object.keys(screens).filter((key)=>"string" == typeof screens[key]).reduce((breakpoints, key)=>({
                ...breakpoints,
                [`screen-${key}`]: screens[key]
            }), {})
};
function mergeExtensionCustomizer(merged, value) {
    return Array.isArray(merged) && (0, _isPlainObject.default)(merged[0]) ? merged.concat(value) : Array.isArray(value) && (0, _isPlainObject.default)(value[0]) && (0, _isPlainObject.default)(merged) ? [
        merged,
        ...value
    ] : Array.isArray(value) ? value : void 0;
}
function resolveConfig(configs) {
    var _t_theme, _c_plugins, themes;
    let allConfigs = [
        ...function extractPluginConfigs(configs) {
            let allConfigs = [];
            return configs.forEach((config)=>{
                var _config_plugins;
                allConfigs = [
                    ...allConfigs,
                    config
                ];
                let plugins = null !== (_config_plugins = null == config ? void 0 : config.plugins) && void 0 !== _config_plugins ? _config_plugins : [];
                0 !== plugins.length && plugins.forEach((plugin)=>{
                    var _plugin_config;
                    plugin.__isOptionsFunction && (plugin = plugin()), allConfigs = [
                        ...allConfigs,
                        ...extractPluginConfigs([
                            null !== (_plugin_config = null == plugin ? void 0 : plugin.config) && void 0 !== _plugin_config ? _plugin_config : {}
                        ])
                    ];
                });
            }), allConfigs;
        }(configs),
        {
            prefix: "",
            important: !1,
            separator: ":"
        }
    ];
    return (0, _normalizeConfig.normalizeConfig)((0, _defaults.defaults)({
        theme: function(object) {
            let resolvePath = (key, defaultValue)=>{
                for (let path of function*(key) {
                    let path = (0, _toPath.toPath)(key);
                    if (0 === path.length || (yield path, Array.isArray(key))) return;
                    let matches = key.match(/^(.*?)\s*\/\s*([^/]+)$/);
                    if (null !== matches) {
                        let [, prefix, alpha] = matches, newPath = (0, _toPath.toPath)(prefix);
                        newPath.alpha = alpha, yield newPath;
                    }
                }(key)){
                    let index = 0, val = object;
                    for(; null != val && index < path.length;)val = isFunction(val = val[path[index++]]) && (void 0 === path.alpha || index <= path.length - 1) ? val(resolvePath, configUtils) : val;
                    if (void 0 !== val) {
                        if (void 0 !== path.alpha) {
                            let normalized = (0, _pluginUtils.parseColorFormat)(val);
                            return (0, _withAlphaVariable.withAlphaValue)(normalized, path.alpha, (0, _toColorValue.default)(normalized));
                        }
                        if ((0, _isPlainObject.default)(val)) return (0, _cloneDeep.cloneDeep)(val);
                        return val;
                    }
                }
                return defaultValue;
            };
            return Object.assign(resolvePath, {
                theme: resolvePath,
                ...configUtils
            }), Object.keys(object).reduce((resolved, key)=>(resolved[key] = isFunction(object[key]) ? object[key](resolvePath, configUtils) : object[key], resolved), {});
        }(function({ extend , ...theme }) {
            return mergeWith(theme, extend, (themeValue, extensions)=>isFunction(themeValue) || extensions.some(isFunction) ? (resolveThemePath, utils)=>mergeWith({}, ...[
                        themeValue,
                        ...extensions
                    ].map((e)=>(function(valueToResolve, ...args) {
                            return isFunction(valueToResolve) ? valueToResolve(...args) : valueToResolve;
                        })(e, resolveThemePath, utils)), mergeExtensionCustomizer) : mergeWith({}, themeValue, ...extensions, mergeExtensionCustomizer));
        }({
            ...(themes = allConfigs.map((t)=>null !== (_t_theme = null == t ? void 0 : t.theme) && void 0 !== _t_theme ? _t_theme : {})).reduce((merged, theme)=>(0, _defaults.defaults)(merged, theme), {}),
            extend: themes.reduce((merged, { extend  })=>mergeWith(merged, extend, (mergedValue, extendValue)=>void 0 === mergedValue ? [
                        extendValue
                    ] : Array.isArray(mergedValue) ? [
                        extendValue,
                        ...mergedValue
                    ] : [
                        extendValue,
                        mergedValue
                    ]), {})
        })),
        corePlugins: function(corePluginConfigs) {
            let result = [
                ...corePluginConfigs
            ].reduceRight((resolved, corePluginConfig)=>isFunction(corePluginConfig) ? corePluginConfig({
                    corePlugins: resolved
                }) : (0, _configurePlugins.default)(corePluginConfig, resolved), _corePluginList.default);
            return result;
        }(allConfigs.map((c)=>c.corePlugins)),
        plugins: function(pluginLists) {
            let result = [
                ...pluginLists
            ].reduceRight((resolved, pluginList)=>[
                    ...resolved,
                    ...pluginList
                ], []);
            return result;
        }(configs.map((c)=>null !== (_c_plugins = null == c ? void 0 : c.plugins) && void 0 !== _c_plugins ? _c_plugins : []))
    }, ...allConfigs));
}
