"use strict";
Object.defineProperty(exports, "__esModule", {
    value: !0
}), Object.defineProperty(exports, "validateConfig", {
    enumerable: !0,
    get: ()=>validateConfig
});
const _log = function(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}(require("./log"));
function validateConfig(config) {
    0 === config.content.files.length && _log.default.warn("content-problems", [
        "The `content` option in your Tailwind CSS configuration is missing or empty.",
        "Configure your content sources or your generated CSS will be missing styles.",
        "https://tailwindcss.com/docs/content-configuration"
    ]);
    try {
        let plugin = require("@tailwindcss/line-clamp");
        config.plugins.includes(plugin) && (_log.default.warn("line-clamp-in-core", [
            "As of Tailwind CSS v3.3, the `@tailwindcss/line-clamp` plugin is now included by default.",
            "Remove it from the `plugins` array in your configuration to eliminate this warning."
        ]), config.plugins = config.plugins.filter((p)=>p !== plugin));
    } catch  {}
    return config;
}
